/*
**			deconv.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>
#include <math.h>

#define OLOP	1
#define ILOP	30
#define HLP	30
#define ADL  2
#define SMPL 3
#define PSFM SMPL
//#define ILOP	100 #define HLP	300	// for inb1.yuv
//#define ILOP	50 #define HLP	50	// for ina3.yuv
//2766 #define H 6 #define V 10
//3026 #define H 12 #define V 8
//2620 #define H 18 #define V 12
//#define H 13 #define V 6		// for ina3.yuv
//#define H 24 #define V 24		// for inb1.yuv ADL
//#define H 16 #define V 16
#define H 16
#define V 16
//data2 #define SX 2560 #define SY 1920
//op  #define SX 1600 #define SY 1200
//op2 #define SX 1280 #define SY 960
//ory #define SX 1024 #define SY 560
//in# #define SX 512  #define SY 512
//inc #define SX 400  #define SY 400
//in_1? #define SX 240 #define SY 320
//in11 #define SX 128 #define SY 128
#ifdef CUT_OUT
#define SX 1280
#define SY 960
#else
#define SX 512
#define SY 512
#endif
//#define GAUSS 1
//#define TST
//#define LPC
//#define Wiener
//#define WienerL
//#define INV_MAT
//#define IIR
#define FP (1.2)
#define IIR1	// hierarchical
//#define IIR2	// divisional
//#define IIR3	// hierarchical & divisional
//#define Unified
//#define BEST	// distingish ests before/after change
//#define Damp	// damped R-L
//#define REAL	// centroid adjustment by float
//#define CENT	// centroid adjust per frame
#define CENTROID	// centroid adjust per layer
#define OFFSET 0	// special offset min value of input is 33 (kif_2620)
#define FULLP

#define HIR  2	// 4 for def., 2 for ina3.yuv
#define EXPD 0	// expand est directly, input as init est, else expanded.
#define AVGE 1	// average est
//#define T 0.000001
#define T 1E-8

//#define GAMMA
//#define sRGB
#ifdef sRGB
#define GMM   2.4
#define IGM   (1./GMM)
#define GRD   12.92
#define LID   0.0031308
#define EXX   0.055
#else
//#define BT709
#ifdef BT709
#define IGM   0.450	// (ITU-R BT.709,SMPTE 170M,240M: 0.45)
#define GMM   (1./IGM)	//
#define GRD   4.500	// (ITU-R BT.709,SMPTE 170M: 4.5,   SMPTE 240M:4.0   )
#define LID   0.018	// (ITU-R BT.709,SMPTE 170M: 0.018, SMPTE 240M:0.0228)
#define EXX   0.099	// (ITU-R BT.709,SMPTE 170M: 0.099, SMPTE 240M:0.1115)
#else
#define GMM   3		//
#define IGM   (1./GMM)	//
#endif
#endif

#define MAX(a,b) (((a)<(b))?(b):(a))
#define MIN(a,b) (((a)>(b))?(b):(a))
#ifdef FULLP
#define LM(a,c) ((MIN(MAX((a),0),(c)-1)))
#else
#define LM(a,c) (a)
#endif

// psf sequence: 32,16,8,4,2  or 35,17,9,5,3 
#define H2 ((H+1)/2)
#define V2 ((V+1)/2)
#define H3 ((H2+1)/2)
#define V3 ((V2+1)/2)
#define H4 ((H3+1)/2)
#define V4 ((V3+1)/2)
#define H5 ((H4+1)/2)
#define V5 ((V4+1)/2)
#define PEX(n) ((n[j/2][i/2]+n[j/2][(i+1)/2]+n[(j+1)/2][i/2]+n[(j+1)/2][(i+1)/2])/4)
#define SPEL(a) ((a[j*2][i*2]+a[j*2][i*2+1]+a[j*2+1][i*2]+a[j*2+1][i*2+1])/4)

#define GE	// EX= SX, EY= SY
#ifdef IIR2
#define GE	// global estimate img
#define FULL
//#define PART
//#define DIVD	// Divide
#endif

#ifdef DIVD
#define DX 4
#define DY 4
#else
#define DX (1<<(HIR-1))
#define DY DX
#endif

// process image buffer size
//#define PX (SX/DX + H + DX)
//#define PY (SY/DY + V + DY)
#define PX SX
#define PY SY

//#define VSEP
#define M (H/2)
#define Fs 512 // Fs >= H
#define U (V/2)
#define P (H)
#define N (P*P)
//#define RECALC	// error recalc
#ifdef BEST
#define best es0	// estmate before change
#else
#define best es		// estimate changing or after change
#endif

#ifdef GE
#define es(y,x) est[sy+y][sx+x]
#define es0(y,x) est0[sy+y][sx+x]
#define in(y,x) inp[sy+y][sx+x]
#define EX SX
#define EY SY
#else
#define es(y,x) est[y][x]
#define es0(y,x) est0[y][x]
#define in(y,x) inp[y][x]
#define EX PX
#define EY PY
#endif
//making yuv file for mpeg encode
//int fr;
//#define iwt(a,b,c,d)
//#define wt(a,b) wtf("n",fr++,a)
#define cp(a,b) memcpy(a,b,sizeof(b))
//-------------------------typedefs---------------------------------------------

typedef unsigned char	Uc;
typedef double		Ft;	// fft data type
typedef double		Mt;	// mat[][] data type
typedef double		dbt;
typedef struct{ Uc y[SY  ][SX  ]; Uc c[2][SY/2][SX/2]; }Sif;
typedef struct{ Ft re; Ft im; } complex;
typedef struct{ int x; int y; } pos;
typedef struct{ pos s; pos e; } rect;

//------------------------static variables-------------------------------------
int accl= 2;	// accellation value
int estm= 3;	// 0:alg0 (error deliver to estimated image by psf)
		// 1:alg1 (err ddeliver to est by psf*est with normalization)
		// 2:lucy // Lucy's algorithm 
		// 3:unified modification of est
int psfm= PSFM;	// 1:lucy rate(chi)^accl * est(xi) (Lucy's PSF modification)
		// 2:adl  not calc 	(deliver same error to est and psf)
		// 3:smpl error(chi)^accl (>th) * est(xi)
		// 4:smpl sqrt(sqrt())
int expd= EXPD;	// 1: expand direct
int avge= AVGE; // 1: average est
int pri= 1;	// print iteration number
int prm= 1;	// print matrix PSF
int pre= 1;	// print error (rms)
int part=0;	// part average of estimate in divisional deconvolution
int iloop= ILOP;
int use_gamma= 1;
int use_expand= 0;	// output [16,255]to[0,255] (for 601 video luma only)
extern int grid;
int peak_pos_x;
int peak_pos_y;

#ifdef GET_PSF
int gpsf= 1;
#else
int gpsf= 0;
#endif

static	Sif	in,ou,ot;	// images
static	Mt	mat2[V][H];	// input h(l,k)
static	Mt	mat3[V][H];	// modified h(l,k)
static	Mt	mat4[V][H];	// highpass
static	Mt	psfa[DY][DX][V][H];	// PSF array
#ifdef VSEP
static	Mt	mats[4][V][H];	// psf is modified
#endif

dbt inp[EY][EX];// input degraded
dbt est[EY][EX];// estimate
dbt est0[EY][EX];// estimate before modified
dbt flt[PY][PX];// filtered and clipped or error
dbt err[PY][PX];// error
dbt rat[PY][PX];// rate error
dbt tmp[EY][EX];// tmporal
dbt cbr[2][EY/2][EX/2];// cb,cr

#ifdef HIR
dbt est2[EY/2][EX/2];// estimate
dbt est20[EY/2][EX/2];// estimate
dbt flt2[EY/2][EX/2];// filtered
dbt inp2[EY/2][EX/2];// input degraded
dbt err2[PY/2][PX/2];// error
dbt rat2[PY/2][PX/2];// rate error
dbt est3[EY/4][EX/4];// estimate
dbt est30[EY/4][EX/4];// estimate
dbt flt3[EY/4][EX/4];// filtered
dbt inp3[EY/4][EX/4];// input degraded
dbt err3[PY/4][PX/4];// error
dbt rat3[PY/4][PX/4];// rate error
dbt est4[EY/8][EX/8];// estimate
dbt est40[EY/8][EX/8];// estimate
dbt flt4[EY/8][EX/8];// filtered
dbt inp4[EY/8][EX/8];// input degraded
dbt err4[PY/8][PX/8];// error
dbt rat4[PY/8][PX/8];// rate error
dbt est5[EY/16][EX/16];// estimate
dbt est50[EY/16][EX/16];// estimate
dbt flt5[EY/16][EX/16];// filtered
dbt inp5[EY/16][EX/16];// input degraded
dbt err5[PY/16][PX/16];// error
dbt rat5[PY/16][PX/16];// rate error
#endif

char name[256]="init";

// for FFT
static complex	wk[Fs][Fs];	// fft buffer
static complex	wkt[Fs][Fs];	// fft buffer
#ifdef WienerL
static complex	winp[Fs][Fs];	// fft buffer
static complex	west[Fs][Fs];	// fft buffer
static complex	wx[Fs][Fs];	// fft buffer
#endif
static complex	wpsf[Fs][Fs];	// fft buffer
static double	matrix[N][N*2];
int xoff,yoff;
//----------------------initial PSF's------------------------------------------
int cx=  H/2; int cy= V/2;
int ix= -H/2; int ax= H-1-H/2;
int iy= -V/2; int ay= V-1-V/2;
#ifdef HIR
int ixa[5]={    -H/2,     -H2/2,     -H3/2,     -H4/2,     -H5/2};
int iya[5]={    -V/2,     -V2/2,     -V3/2,     -V4/2,     -V5/2};
int axa[5]={ H-1-H/2, H2-1-H2/2, H3-1-H3/2, H4-1-H4/2, H5-1-H5/2};
int aya[5]={ V-1-V/2, V2-1-V2/2, V3-1-V3/2, V4-1-V4/2, V5-1-V5/2};
#endif
#define O 0
static Uc mat[V*H];
/*
static Uc mat[V*H]={ // half
  0,0,0,0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0,  0, 53, 67,  0,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0,  0, 99,139, 73,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0, 49,163,185, 63,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0, 97,191,147, 27,  0,0,0,
  0,0,0,0, 0,  0,  0,  0, 54,134,176, 74,  0,  0,0,0,
  0,0,0,0, 0,  0, 23, 41, 92,151,111, 39,  0,  0,0,0,
  0,0,0,0, 0,  0, 10, 85,140,153, 62,  5,  0,  0,0,0,
  0,0,0,0, 0,  0, 21,122,180,156, 31,  0,  0,  0,0,0,
  0,0,0,0, 0,  0, 26,103,173,151, 33,  0,  0,  0,0,0,
  0,0,0,0, 0,  0, 25, 70,159,151, 37, 10,  0,  0,0,0,
  0,0,0,0, 0,  0,  0, 75,164,152, 31,  2,  0,  0,0,0,
  0,0,0,0, 0,  0,  0, 72,126,111, 20,  6,  0,  0,0,0,
  0,0,0,0, 0,  0,  0, 36, 52, 45,  8,  0,  0,  0,0,0,
  0,0,0,0, 0,  0,  0,  0, 16, 15, 11,  0,  0,  0,0,0,
  0,0,0,0, 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,0,0,
};
*/
//---- gamma(power of 2.22)  and inverse gamma (power of 0.45)------------------
//int hist[256];
dbt
gamma_(dbt v){	// ~ pow(x/255,2.222)
	//int i= v; hist[i]++;
	v= (v - OFFSET)/255.;

	if(v<0.) v= 0.; if(v>1.) v= 1.;

	if(use_gamma){
#ifdef GAMMA
	if(v< LID*GRD) v/= GRD;
	else v= pow((v+EXX)/(1+EXX),GMM);
#else
	v= pow(v,GMM);
#endif
	}
	if(v<0.) v= 0.; if(v>1.) v= 1.;

	return v;
}
int
igamma(dbt v){	// ~ pow(x,0.45)*255
	int i;
	if(v<0.) v= 0.; if(v>1.) v= 1.;

	if(use_gamma){
#ifdef GAMMA
	if(v< LID) v*= GRD;
	else v= (1+EXX)*pow(v,IGM)-EXX;
#else
	v= pow(v,IGM);
#endif
	}
	v= 255.*v + OFFSET;
	if(use_expand) v= (v-16)*255/(235-16);//16-235=>0-255(ITU-R601 luma)
	i= v+.5;
	if(i<0)i= 0; if(i>255)i= 255;
	return i;
}
//----------------------- print array ------------------------------------------
void
pr_mat(Mt m[V][H]) {
	int i,j;
	for(j=0;j<V;j++){
		for(i=0;i<H;i++) {
			if(m[j][i]==0) printf("  - ");
			else printf("%3d ",(int)(m[j][i]*V*H));
		}
		printf("\n");
	}
	printf("\n");
}
#ifdef HIR
void
pr_mat_hir(int h, int v, Mt m[v][h]) {
	int i,j;
	for(j=0;j<v;j++){
	for(i=0;i<h;i++){
		if(m[j][i]==0) printf(" -");
		else printf("%2d",(int)(m[j][i]*v*h));
	}
	printf("\n");
	}
	printf("\n");
}
#endif

//----------------------- small array funcs ------------------------------------
void clr(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= 0; }
void no_minus(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) if(a[j][i]<0) a[j][i]= 0; }
void plus(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= fabs(a[j][i]); }
void sqr(Mt a[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= sqrt(a[j][i]); }
void mls(Mt a[V][H],Mt b) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]*= b; }
void add(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]+= b[j][i]; }
void add2(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]+= b[j][i]/3; }
void sub(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]-= b[j][i]; }
void mlt(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]*= b[j][i]; }
void dvd(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]/= b[j][i]; }
void cpy(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]=  b[j][i]; }
void subs(Mt a[V][H],int c) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) { a[j][i]-= c; if(a[j][i]<0)a[j][i]= 0;} }
void avg(Mt a[V][H],Mt b[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= (a[j][i]+b[j][i])/2; }
dbt  sum(Mt a[V][H]) { int i,j; dbt s= 0; for(j=0;j<V;j++) for(i=0;i<H;i++) s+= a[j][i]; return s; }
void clrl(Mt* a,      int l)	{ int i; for(i=0;i<l;i++) a[i]= 0; }
void addl(Mt* a,Mt* b,int l)	{ int i; for(i=0;i<l;i++) a[i]+= b[i]; }
void mltl(Mt* a,Mt* b,int l)	{ int i; for(i=0;i<l;i++) a[i]*= b[i]; }
void mlsl(Mt* a,Mt s, int l)	{ int i; for(i=0;i<l;i++) a[i]*= s; }
void intpl(Mt* a,Mt* b, Mt s, int l)	{ int i; for(i=0;i<l;i++) a[i]+= (b[i]-a[i])*s; }
void cpyl(Mt* a,Mt* b,int l)	{ int i; for(i=0;i<l;i++) a[i]= b[i]; }
void avgl(Mt* a,Mt* b,int l)	{ int i; for(i=0;i<l;i++) a[i]= (a[i]+b[i])/2; }
void
shrink_img(int ex,int ey, dbt b[][ex], dbt a[][ex*2]) {
int i,j; for(j=0;j<ey;j++) for(i=0;i<ex;i++) b[j][i]= SPEL(a);
}
void
expand_img(int ex, int ey, dbt a[][ex], dbt b[][ex/2]) {
int i,j; for(j=0;j<ey;j++) for(i=0;i<ex;i++) a[j][i]= PEX(b);
//int i,j; for(j=0;j<ey;j++) { for(i=0;i<ex-1;i++) a[j][i]= PEX(b); a[j][i]= b[j/2][i/2]; }
}
void
expand_direct(int l, dbt a[][EX], dbt c[][EX>>l]) {
int i,j; for(j=0;j<EY;j++) for(i=0;i<EX;i++) a[j][i]= c[j>>l][i>>l];
}
void
flat_psf(Mt* m, int len) { int i; for(i=0;i<len;i++) m[i]= 1./len; }
void
shrink_psf(int h, int v, int h2, int v2, Mt m[][h], Mt n[][h2]) {
int i,j; for(j=0;j<v;j++) for(i=0;i<h;i++) m[j][i]= SPEL(n); norm_hir(h,v,m);
}

#ifdef REAL
// centroid adjuctment by linear interpolation
void
centroid2(int h, int v, Mt m[][h], Mt t[][h])
{
	int i,j,k,l,x,y; Mt a,b,d,e, cx= 0, cy= 0, s= 0;

	x= h/2;
	y= v/2;
	a= .001/(h*v);
	for(j=0;j<v;j++)
	for(i=0;i<h;i++) { s+= d= t[j][i]; cx+= d*(i-x); cy+= d*(j-y); m[j][i]= a; }
	cx/= s;
	cy/= s;

	x= (int)cx - (cx<0);
	y= (int)cy - (cy<0);

	d= cx - x;
	e= cy - y;

	for(j=0;j<v;j++) { l= j+y; if(l<0)l= 0; if(l>v-2)l= v-2;
	for(i=0;i<h;i++) { k= i+x; if(k<0)k= 0; if(k>h-2)k= h-2;
		a= t[l  ][k] + d*(t[l  ][k+1] - t[l  ][k]);
		b= t[l+1][k] + d*(t[l+1][k+1] - t[l+1][k]);
		m[j][i]= a + e*(b-a);
	}}
	//norm_hir(h,v,m);
}
void
expand_psf(int h, int v, int h2, int v2, Mt m[][h], Mt n[][h2]) {
	int i,j; Mt t[v][h];
	for(j=0;j<v;j++) for(i=0;i<h;i++) t[j][i]= PEX(n);
#ifdef CENTROID
	centroid2(h, v, m, t);
#endif
	if(prm)printf("psf expanded\n");
	norm_hir(h,v,m);
}
#else
void
expand_psf(int h, int v, int h2, int v2, Mt m[][h], Mt n[][h2]) {
#ifdef CENTROID
	int i,j,x,y; Mt d,e, cx= 0, cy= 0, s= 0, t[v][h];
	x= h/2;
	y= v/2;
	for(j=0;j<v;j++)
	for(i=0;i<h;i++) {
		s+= d= t[j][i]= PEX(n);
		cx+= d*(i-x);
		cy+= d*(j-y);
		m[j][i]= .001/(h*v);
	}
	x= cx/s; y= cy/s;
	if(prm)printf("expand_psf: psf is shifted (%d, %d) to zero.\n",x,y);
	for(j=MAX(-y,0);j<MIN(v,v-y);j++)
	for(i=MAX(-x,0);i<MIN(h,h-x);i++) m[j][i]= t[j+y][i+x];
#else
int i,j; for(j=0;j<v;j++) for(i=0;i<h;i++) m[j][i]= PEX(n);
/*
int i,j; for(j=0;j<v-1;j++) { for(i=0;i<h-1;i++) m[j][i]= PEX(n); m[j][i]= n[j/2][i/2]; }
	 for(i=0;i<h-1;i++) m[j][i]= (n[j/2][i/2]+n[j/2][(i+1)/2])/2; m[j][i]= n[j/2][i/2];
*/
#endif
	if(prm)printf("psf expanded\n");
	norm_hir(h,v,m);
}
#endif

//---------------- between Sif image and dbt image array -----------------------
// Sif (upleft (sx,sy) to (ex-1,ey-1)) ==> dbt array
void
sif2dbl(rect *r, int ex, Uc p[][ex],dbt b[][ex])
{
	int i,j;
	for(j=r->s.y;j<r->e.y;j++)
	for(i=r->s.x;i<r->e.x;i++) b[j-r->s.y][i-r->s.x]= gamma_((dbt)p[j][i]);
	//for(i=0;i<256;i++)printf("%d\n",hist[i]); printf("\n");
}
void
sif2x(rect *re, int ex, Sif *p, dbt x[][ex])
{
	int i,j; dbt y,u,v,r,g,b;
	for(j=re->s.y;j<re->e.y;j++)
	for(i=re->s.x;i<re->e.x;i++) {
		y= p->y[j][i];
		u= (int)p->c[0][j/2][i/2]-128;
		v= (int)p->c[1][j/2][i/2]-128;	// Y,Cb,Cr
		r= y+1.402*v;
		g= y-0.34414*u-0.71414*v;
		b= y+1.772*u;		// R,G,B
		r= gamma_(r);
		g= gamma_(g);
		b= gamma_(b);		// R',G',B'
		x[j-re->s.y][i-re->s.x]= y= r*0.29891+g*0.58661+b*0.11448;//Y'
		cbr[0][j/2][i/2]= (y-b)*(1./1.772)+.5;
		cbr[1][j/2][i/2]= (y-r)*(1./1.402)+.5;
	}
}
#ifdef GE
void
sif2g_est(Sif *p, dbt b[SY][SX])	// copy whole sif to double type image
{
	int i,j;
	for(j=0;j<SY;j++)
	for(i=0;i<SX;i++) b[j][i]= gamma_((dbt)p->y[j][i]);
}
// ===> back to Sif(sx,sy)-(ex-1,ey-1)
void
dbl2sif(rect *ir, rect *or, int sx, dbt b[][sx], Uc p[][sx]) // copy back selected area
{
	int i,j,dx,dy;
	dx= or->s.x - ir->s.x;
	dy= or->s.y - ir->s.y;
	for(j=or->s.y;j<or->e.y;j++)
	for(i=or->s.x;i<or->e.x;i++) p[j][i]= igamma(b[j][i]);
}
void
x2sif(rect *ir, rect *or, int sx, dbt x[][sx], Sif *p) // copy back selected area
{
	int i,j,dx,dy; dbt y,u,v,r,g,b;
	dx= or->s.x - ir->s.x;
	dy= or->s.y - ir->s.y;
	for(j=or->s.y;j<or->e.y;j++)
	for(i=or->s.x;i<or->e.x;i++) {
		y= x[j][i];
		u= cbr[0][j/2][i/2]-.5;
		v= cbr[1][j/2][i/2]-.5;
		r= y+1.402*v;
		g= y-0.34414*u-0.71414*v;
		b= y+1.772*u;
		r= igamma(r);
		g= igamma(g);
		b= igamma(b);
		y= r*0.29891+g*0.58661+b*0.11448;
		u= (y-b)*(1./1.772);
		v= (y-r)*(1./1.402);
		p->y[j][i]= y;
		p->c[0][j/2][i/2]= u+128;
		p->c[1][j/2][i/2]= v+128;
	}
}
#else
void
dbl2sif(rect *ir, rect *or, int px, dbt b[][px], Uc p[][px])
{
	int i,j,dx,dy;
	dx= or->s.x - ir->s.x;
	dy= or->s.y - ir->s.y;
	for(j=0;j<or->e.y - or->s.y;j++)
	for(i=0;i<or->e.x - or->s.x;i++) p[j+ or->s.y][i+ or->s.x]= igamma(b[j+dy][i+dx]);
}
#endif

//------ normalize (only from ix to ax, from iy to ay)-----------------
int
norm1(Mt m[V][H], double c) // normalize sum of mat to 1.
{
	int i,j; double sum= 0;
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) sum+= m[j+U][i+M];
	sum/= c; //printf("normalize sum:%f to %f\n",sum,c);
	if(sum==0.) return 1;
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) m[j+U][i+M]/= sum;
	return 0;
}
int
norm_hir(int h, int v, Mt m[v][h])
{
	int i,j; dbt sum= 0;
	//for(j=0;j<v;j++) for(i=0;i<h;i++) m[j][i]= MAX(0,m[j][i]);
	for(j=0;j<v;j++) for(i=0;i<h;i++) sum+= m[j][i];
	if(sum==0.) { printf("norm_hir: psf wrong\n"); }
	else for(j=0;j<v;j++) for(i=0;i<h;i++) m[j][i]/= sum;
	if(prm)pr_mat_hir(h,v,m);
	return 0;
}
Mt m1[V][H];
Mt last_err;
Mt lastm[V][H];

//----------------------- mk_unif --------------------------------
void
mk_unif(rect *or, rect *of, Mt psf[V][H]) // filter estimate by psf
{
	int i,j,k,l,c; dbt a,e,s;
	int sx= or->s.x; int dx= or->e.x - sx;	// used as pos
	int sy= or->s.y; int dy= or->e.y - sy;	// by es(),in()
	Mt b[V][H];
lo:
	if(psfm==2) clr(m1);
#ifdef BEST
	cp(est0,est);	// est before modified
#endif
	s= c= 0;
	for(j=of->s.y;j<of->e.y;j++)
	for(i=of->s.x;i<of->e.x;i++) {	// flt, err, rat area
		a= 0;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++)
			a+= b[l+U][k+M]= best(j-l,i-k)*psf[l+U][k+M];
		if(a< T) a= T; if(a> 1.) a= 1.;
		flt[j][i]= a;
		err[j][i]= in(j,i)-a;
		rat[j][i]= in(j,i)/a;
		s+= err[j][i] * err[j][i]; c++;
		a= err[j][i]/a;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) { e= a*b[l+U][k+M]; es(j-l,i-k)+= e; m1[l+U][k+M]+= e; }
	}
	s/= c;
	if(last_err!=0 && s>last_err) { avg(psf,lastm); goto lo; }
	else { last_err= s; cpy(lastm,psf); }
	if(pre)printf(" %f\n",sqrt(s));
}

//----------------------- make error ------------------------------------------
void
mk_err(rect *or, rect *of, Mt psf[V][H]) // filter estimate by psf
{
	int i,j,k,l,c=0;
	int sx= or->s.x; int dx= or->e.x - sx;	// used as pos
	int sy= or->s.y; int dy= or->e.y - sy;	// by es(),in()
	Mt s= 0;
lo:
	s= c= 0;
	for(j=of->s.y;j<of->e.y;j++)
	for(i=of->s.x;i<of->e.x;i++) {	// flt, err, rat area
		dbt a= 0;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) a+= es(j-l,i-k) * psf[l+U][k+M];
		if(a< T) a= T; if(a> 1.) a= 1.;
		flt[j][i]= a;
		err[j][i]= in(j,i)-a;
		rat[j][i]= in(j,i)/a;
		s+= err[j][i] * err[j][i];
		c++;
	}
	s/= c;
	//if(last_err!=0 && s>last_err) { cpy(psf,lastm); goto lo; }
	if(last_err!=0 && s>last_err) { avg(psf,lastm); goto lo; }
	else { last_err= s; cpy(lastm,psf); }
	if(pre)printf(" %f\n",sqrt(s));
}

//---------------------------make estimate image -------------------------------
void
mk_est(rect *or, rect *ir, Mt psf[V][H]) // modify estimate
{
	int i,j,k,l,x1,x2,y1,y2,v; dbt a,e;
	int sx= or->s.x; int dx= or->e.x - sx;	// used as pos of est
	int sy= or->s.y; int dy= or->e.y - sy;
	Mt b[V][H];

	if(psfm==2) clr(m1);
#ifdef BEST
	cp(est0,est);// to separate est before modified
#endif
	if(estm==0) { // alg0
	for(j=ir->s.y;j<ir->e.y;j++)
	for(i=ir->s.x;i<ir->e.x;i++) {
		//est[j][i]+= err[j][i]*0.05;
		a= err[j][i];
		for(l= iy;l<=ay;l++)	// deliver err to est
		for(k= ix;k<=ax;k++) es(j-l,i-k) += a * psf[l+U][k+M];
	}
	/*
	for(j=ir->s.y;j<ir->e.y;j++)
	for(i=ir->s.x;i<ir->e.x;i++) {
		a= 0;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) a+= err[j+l][i+k] * psf[l+U][k+M];
		es(j,i) += a;
	}
	*/
	} else	if(estm==1) { // alg1
	for(j=ir->s.y;j<ir->e.y;j++)
	for(i=ir->s.x;i<ir->e.x;i++) {
		a= 0;
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) a+= b[l+U][k+M]= best(j-l,i-k)*psf[l+U][k+M];

		//if(a< T) a= T; if(a> 1.) a= 1.;
		a= err[j][i]/a;
		//a= err[j][i]/flt[j][i];

		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) {
			e= a*b[l+U][k+M];
			es(j-l,i-k)+= e;
			if(psfm==2) m1[l+U][k+M]+= e;
		}
	}
	} else if(estm==2) { // lucy
	for(j=0;j<dy;j++)
	for(i=0;i<dx;i++) {
		a= 0; if(psfm==2) e= es(j,i);
		for(l= iy;l<=ay;l++)
		for(k= ix;k<=ax;k++) {
			if(j+l>=U && j+l<dy-U && i+k>=M && i+k<dx-M) {
			a+= rat[j+l][i+k] * psf[l+U][k+M];
			if(psfm==2) m1[l+U][k+M]+= e*(rat[j+l][i+k]-1)* psf[l+U][k+M];
			} else a+= psf[l+U][k+M];
		}
		es(j,i)*= a;
	}
	}
	for(j=0;j<dy;j++)
	for(i=0;i<dx;i++) if(es(j,i)<0) es(j,i)= 0;
}

//----------------------- centroid_of_psf --------------------------------------
int
centroid(int sx, int sy, int dx, int dy, Mt m[V][H])
{
	int i,j,x,y; Mt cx=0,cy=0; Mt t[V][H];

	if(norm1(m,(double)1.)) return 1;

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) { Mt d= m[j][i]; cx+= d*(i-M); cy+= d*(j-U); }

	x= cx; y= cy;

	if(x|y){
		printf("cent=(%4.2f,%4.2f)\n",cx,cy);
		cpy(t,m); cp(tmp,est);
		if(y>=0)
		for(j=0;j<V-y;j++) {
			if(x>=0) for(i=0;i<H-x;i++) m[j][i]= t[j+y][i+x];
			else	 for(i=-x;i<H;i++)  m[j][i]= t[j+y][i+x];
		}
		else for(j=-y;j<V;j++) {
			if(x>=0) for(i=0;i<H-x;i++) m[j][i]= t[j+y][i+x];
			else	 for(i=-x;i<H;i++)  m[j][i]= t[j+y][i+x];
		}
		if(y>=0)
		for(j=0;j<dy-y;j++) {
			if(x>=0) for(i=0;i<dx-x;i++) es(j+y,i+x)= tmp[j][i];
			else	 for(i=-x;i<dx;i++)  es(j+y,i+x)= tmp[j][i];
		}
		else for(j=-y;j<dy;j++) {
			if(x>=0) for(i=0;i<dx-x;i++) es(j+y,i+x)= tmp[j][i];
			else	 for(i=-x;i<dx;i++)  es(j+y,i+x)= tmp[j][i];
		}
		//if( norm1(m,(double)1.)) return 1; 
		printf("moved %d %d\n",x,y);
	}
	return 0;
}

void
show_psf(Mt m[V][H])
{
	int k,l;
	for(l=iy;l<=ay;l++)
	for(k=ix;k<=ax;k++) {
dbt d= m[l+U][k+M]*256*50; if(d<0)d=0; if(d>255)d= 255; est[l+U][k+M]= d/255.;
	}
}

//----------------- move psf ---------(estimate psf)----------------------------
int
move_psf(rect *or, rect *of, Mt m[V][H])
{
	int i,j,k,l,c;
	int sx= or->s.x; int dx= or->e.x - sx;
	int sy= or->s.y; int dy= or->e.y - sy;
	Mt a,e=0;
	if(psfm==2){
		for(j=0;j<PY;j++)
		for(i=0;i<PX;i++) e+= best(j,i);
		mls(m,e/accl);
		add(m,m1);
	} else if(psfm) {

	for(l=iy;l<=ay;l++)
	for(k=ix;k<=ax;k++) {
		a= 0;
		for(j=of->s.y;j<of->e.y;j++)
		for(i=of->s.x;i<of->e.x;i++){
#ifdef RECALC
			dbt b= es(j-l,i-k);
#else
			dbt b= best(j-l,i-k);
#endif
			if(psfm==1) e= rat[j][i];
			else e= err[j][i];
			if(e>0){ for(c= 0;c<accl;c++) b*= e; a+= b; }
		}
		m1[l+U][k+M]= a;
	}
	if(psfm==3) sqr(m1);
	if(psfm==4) { sqr(m1); sqr(m1); }
	if(sum(m1)) mlt(m,m1);
	else printf("m1 is all 0\n");
	no_minus(m);

	}
	//centroid(sx,sy,dx,dy,m);
	if(norm1(m,(double)1.)) return 1;
	//show_psf(m);
	if(prm)pr_mat(m);
	return 0;
}

//--------- direction preserve filter ------------------------------
void
dfilter(int th)
{
	int i,j,k,l;
	Mt ul,uc,ur,cl,cc,cr,dl,dc,dr,hd,vd,rd,ld,min,res;
	for(j=1;j<PY-1;j++)
	for(i=1;i<PX-1;i++) {
		ul= est[j-1][i-1];
		uc= est[j-1][i];
		ur= est[j-1][i+1];
		cl= est[j  ][i-1];
		cc= est[j  ][i];
		cr= est[j  ][i+1];
		dl= est[j+1][i-1];
		dc= est[j+1][i];
		dr= est[j+1][i+1];
		hd= fabs(cl+cr-2*cc);
		vd= fabs(uc+dc-2*cc);
		rd= fabs(dl+ur-2*cc);
		ld= fabs(dr+ul-2*cc);
		min= th; res= cc;
		if(hd<min) {min= hd; res= (cl+cr+2*cc)/4; }
		if(vd<min) {min= vd; res= (uc+dc+2*cc)/4; }
		if(rd<min) {min= rd; res= (dl+ur+2*cc)/4; }
		if(ld<min) {min= ld; res= (dr+ul+2*cc)/4; }
		flt[j][i]= res;
	}
	cp(est,flt);
}

//-----------------epsilon filter------------------------------
void
efilter(int th)
{
	int i,j,k,l,cnt;
	Mt c,d,sum;
	for(j=1;j<PY-1;j++)
	for(i=1;i<PX-1;i++) {
		c= est[j][i];
		sum= c;
		cnt= 1;
		for(l=-1;l<=1;l++)
		for(k=-1;k<=1;k++){
			d= est[j+l][i+k];
			if(fabs(d-c)<= th){ sum+= d; cnt++; }
		}
		flt[j][i]= sum/cnt;
	}
	cp(est,flt);
}

void
init_pic(int val, Mt p[PY][PX]){
	int i,j;
	for(j=0;j<PY;j++)
	for(i=0;i<PX;i++) p[j][i]= val;
}

void
write_out_psf_jpg(int lp, char *n, Mt m[V][H])
{
	write_out(sizeof(Sif),"o.yuv");
	//sprintf(n,"%d.psf",lp); write_psf(n, m);
	sprintf(n,"convert -size %dx%d o.yuv out%d.jpg",SX,SY,lp); system(n);
}

/*
**	iterational inverse filter (IIR2)
*/
int
iir2(int o,int i,int j,rect *or,rect *ir,rect *of,Mt m[V][H])
{	
	int lp;
	if(norm1(m,(double)1.)) return 1;
#ifndef GE
	sif2dbl(or,EX,&in.y,inp);
	cp(est,inp);
	//init_pic(gamma_((dbt)40.),est);
#endif
	last_err= 1.0;
	for(lp= 0;lp<iloop;lp++){
		if(pri) printf("lp= %d\t",lp);
		if(estm==3)mk_unif(or,of,m);
		else { mk_err(or,of,m); mk_est(or,of,m); }
#ifdef RECALC
		mk_err(or,of,m);
#endif
		if(move_psf(or,of,m)) break;
		//efilter(1);
		dbl2sif(or,ir,EX,est,ot.y);
		sprintf(name,"o=%d (y=%d,x=%d,it=%4d)", o, j, i, lp);
		wt(&ot,name); // display on X-window
		//if(lp%100==0)write_out_psf_jpg(lp, name, m);
	}
	//efilter(1); dbl2sif(or,ir,EX,est,ot.y);
	//write_out_psf_jpg(lp, name, m);
	return 0;
}
//---
void
norm(Mt m[V][H], double c) // normalize sum of mat to be 1.
{
	int i,j; double sum= 0;
	for(j=0;j<V;j++) for(i=0;i<H;i++) sum+= m[j][i];
	sum/= c; //printf("normalize by:%f\n",sum);
	for(j=0;j<V;j++) for(i=0;i<H;i++) m[j][i]/= sum;
}

/*
**	inv_mat(): inverse matrix
**	input: set square (n x n) matrix left half, and unit matrix right half.
**	output: unit made on left side, inverse matrix is made right side.
**	note: use double as matrix element type, index i,j of aji bji are 0 to n-1.
*/
void
inv_mat(int n, int m)	// inverse matrix (n x n), use m x n matrix (m= 2n)
{
	int i,j,k; double a;
	for(k=   0; k<n; k++)
	for(j= k+1; j<n; j++) { a= matrix[j][k]/matrix[k][k]; for(i=k;i<m;i++) matrix[j][i]-= matrix[k][i]*a; }
	for(j=   0; j<n; j++) { a= 1./matrix[j][j]; for(i=j;i<m;i++) matrix[j][i]*= a; }
	for(k= n-1;k>=0; k--)
	for(j= k-1;j>=0; j--) { a= matrix[j][k]; for(i=k;i<m;i++) matrix[j][i]-= matrix[k][i]*a; }
}


/*
**	put_mat: put mat[V][H] to matrix[N][N] (N= P*P (P= H)),
**	matrix[j][i]= mat[y][x] when (-M <=y[i]-y[j]< M && -M<=x[i]-x[j]< M)
**	and make unit-matrix on the right half of the matrix (i: column, j: raw)
*/
void
put_mat(Mt m[V][H])
{
	int i,j;
	for(j=0;j<N;j++)
	for(i=0;i<N;i++) {
		int dy= (i/P)-(j/P);
		int dx= (i%P)-(j%P);
		if(dy<U && dy>=-U && dx<M && dx>=-M) matrix[j][i]= m[dy+U][dx+M];
		matrix[j][i+N]= (i==j);
	}
}

#define Center (M*H+M)
#define skip_center(i) (i+(i>=Center))
void
put_mat_sk(Mt m[V][H])
{
	int i,j;
	for(j=0;j<N-1;j++) {
		int j1= skip_center(j);
	for(i=0;i<N-1;i++) {
		int i1= skip_center(i);
		int dy= (i1/P)-(j1/P);
		int dx= (i1%P)-(j1%P);
		if(dy<U && dy>=-U && dx<M && dx>=-M) matrix[j][i]= m[dy+U][dx+M];
		matrix[j][i+N]= (i==j);
	}}
}

#define CN ((P+1)*P/2)
#define CM (M*P+M)
void
get_mat(Mt m[V][H],int x, int y)	//	get center pel raw
{
	int i,j;
	int off= y*P+x;
	for(j=0;j<V;j++) for(i=0;i<H;i++) m[j][i]= matrix[CN+off][CN+off+j*P+i-CM+N];
}

void
fft(complex *x,int n,int f)	// 2's power FFT
{
	int	mm,m,j,i;
	complex t,wp,w;
	for (j= i= 0; i< n; i++) { // bit reversal replacement
		if (j>i) { t= x[j]; x[j]= x[i]; x[i]= t; }	// exchange x[i],x[j]
		m= n>>1;
		while (m>=2 && j>=m) { j-= m; m>>= 1; }		// revsl-increment j
		j+= m;
	}
	wp.re= -1; wp.im=  0;	// initial wp= exp(-j pai)
	for (mm=1; mm< n; mm<<=1) {
		w.re= 1; w.im= 0;
		for (m=0; m<mm; m++) {
			j= m+mm;
			for (i= m; i< n; i+= mm*2, j+= mm*2) {
				t.re= w.re * x[j].re - w.im * x[j].im;// rotate x[j] by w
				t.im= w.re * x[j].im + w.im * x[j].re;// add and subtr
				x[j].re= x[i].re - t.re; x[j].im= x[i].im - t.im;
				x[i].re= x[i].re + t.re; x[i].im= x[i].im + t.im;
			}
			t= w;	// rotate w by wp
			w.re= t.re*wp.re - w.im*wp.im;
			w.im= t.re*wp.im + w.im*wp.re;
		}
		wp.im= sqrt(.5-wp.re*.5)*f;			// halve argment of wp
		wp.re= sqrt(.5+wp.re*.5);			// f= -1: fft, 1: ifft
	}
}

void ft2(int n, complex w[][n]) { fft(&w[0][0],n*n,-1); }
void it2(int n, complex w[][n]) {
int i,j; dbt c= 1./(n*n); fft(&w[0][0],n*n,1); 
for(j=0;j<n;j++) for(i=0;i<n;i++){ wk[j][i].re*= c; wk[j][i].im*= c; }
}
#define FT(a) ft2(Fs,a)
#define IT(a) it2(Fs,a)
/* 2-dimensional fft deduces exactly same !
void
fft2(int n, complex w[][n],int f)
{
	int i,j;
	dbt c= 1.;
	for(j=0;j<n;j++) fft(w[j],n,f);
	for(j=0;j<n;j++)
	for(i=0;i<n;i++) wkt[i][j]= w[j][i];
	for(j=0;j<n;j++) fft(wkt[j],n,f);
	if(f==1) c= 1./(n*n);
	for(j=0;j<n;j++)
	for(i=0;i<n;i++) { w[i][j].re= wkt[j][i].re*c; w[i][j].im= wkt[j][i].im*c; }
}
*/

void prep_fft(Mt m[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) wk[j][i].re= m[j][i]; }
void prep_fir(Mt m[V][H]) { int i,j; for(j=0;j<V;j++) for(i=0;i<H;i++) m[j][i]= wk[j][i].re; }
void set_fft(complex wk[Fs][Fs], Mt m[SY][SX]) { int i,j; for(j=0;j<SY;j++) for(i=0;i<SX;i++) wk[j][i].re= m[j][i]; }
void get_fft(complex wk[Fs][Fs], Mt m[SY][SX]) { int i,j; for(j=0;j<SY;j++) for(i=0;i<SX;i++) m[j][i]= wk[j][i].re; }
void get_wk(Mt m[V][H], complex w[Fs][Fs]) {
	int i,j;
	for(j=0;j<V/2;j++){
		for(i=0;i<H/2;i++) m[j][i]= w[Fs-V/2+j][Fs-H/2+i].re;
		for(i=H/2;i<H;i++) m[j][i]= w[Fs-V/2+j][i-H/2].re;
	}
	for(j=V/2;j<V;j++){
		for(i=0;i<H/2;i++) m[j][i]= w[-V/2+j][Fs-H/2+i].re;
		for(i=H/2;i<H;i++) m[j][i]= w[-V/2+j][i-H/2].re;
	}
}

void
pr_freq(void)
{
	int i,j;
	for(j=0;j<Fs;j++){ printf("\n"); for(i=0;i<Fs;i++) printf("%5.2f ",wk[j][i].re); } printf("\n");
	for(j=0;j<Fs;j++){ printf("\n"); for(i=0;i<Fs;i++) printf("%5.2f ",wk[j][i].im); } printf("\n");
}
void
pr_power(void)
{
	int i,j;
	for(j=0;j<Fs;j++){ printf("\n"); for(i=0;i<Fs;i++) printf("%5.2f ",
	wk[j][i].re * wk[j][i].re +wk[j][i].im * wk[j][i].im); } printf("\n");
}
//#define S .08
#define S 0.01
//#define S .1
void md(// muldiv
	complex d[Fs][Fs],
	complex a[Fs][Fs],
	complex b[Fs][Fs], int f)
{
	int i,j; double ma,ra,mb,rb,c= 1.;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		ra= a[j][i].re; ma= a[j][i].im;
		rb= b[j][i].re; mb= b[j][i].im;
		if(f) { c= rb*rb+mb*mb; mb= -mb; if(c< S) c= S; }
		d[j][i].re= (ra*rb-ma*mb)/c;
		d[j][i].im= (ma*rb+ra*mb)/c;
	}
}
void rv(complex a[Fs][Fs])	// a= 1/a 
{
	int i,j; dbt ma,ra,pw;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		ra= a[j][i].re;
		ma= a[j][i].im;
		pw= ra*ra+ma*ma;
		if(pw< S) pw= S;
		a[j][i].re= ra/pw;
		a[j][i].im= -ma/pw;
	}
}
void rd1(// realdiv
	complex d[Fs][Fs],
	complex a[Fs][Fs],
	complex b[Fs][Fs], int f)
{
	int i,j; double ma,ra,mb,rb;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		ra= a[j][i].re; ma= a[j][i].im;
		rb= b[j][i].re; mb= b[j][i].im;
		if(f) { if(rb<S) rb= S; d[j][i].re= ra/rb;
			if(mb<S) mb= S; d[j][i].im= ma/mb; }
		else  { d[j][i].re= ra*rb; d[j][i].im= ma*rb; }
	}
}
void mult(complex d[Fs][Fs], complex a[Fs][Fs], complex b[Fs][Fs]) { md(d,a,b,0); }
void divd(complex d[Fs][Fs], complex a[Fs][Fs], complex b[Fs][Fs]) { md(d,a,b,1); }
void rmul(complex d[Fs][Fs], complex a[Fs][Fs], complex b[Fs][Fs]) { rd1(d,a,b,0); }
void rdiv(complex d[Fs][Fs], complex a[Fs][Fs], complex b[Fs][Fs]) { rd1(d,a,b,1); }
void mda( complex d[Fs][Fs], complex a[Fs][Fs], complex b[Fs][Fs], int f) // muldiv and add
{
	int i,j; double ma,ra,mb,rb,c= 1.;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		ra= a[j][i].re; ma= a[j][i].im;
		rb= b[j][i].re; mb= b[j][i].im;
		if(f) { c= rb*rb+mb*mb; mb= -mb; if(c< S) c= S; }
		d[j][i].re+= (ra*rb-ma*mb)/c;
		d[j][i].im+= (ma*rb+ra*mb)/c;
	}
}
void
mnorm(complex a[Fs][Fs])
{
	int i,j; double sum= 0;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		/*
		sum+=a[j][i].re;
		a[j][i].im=0;
		*/
		sum+= a[j][i].re * a[j][i].re + a[j][i].im * a[j][i].im;
	}
	sum= sqrt(sum);
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){ a[j][i].re/= sum; a[j][i].im/= sum; }
}
void
msub( complex a[Fs][Fs], complex b[Fs][Fs])
{
	int i,j; double ma,ra,mb,rb,c= 1.;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		ra= a[j][i].re; ma= a[j][i].im;
		rb= b[j][i].re; mb= b[j][i].im;
		a[j][i].re= rb-ra;	// A= B-A
		a[j][i].im= mb-ma;
	}
}
void
madd( complex a[Fs][Fs], complex b[Fs][Fs])
{
	int i,j; double ma,ra,mb,rb,c= 1.;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		ra= a[j][i].re; ma= a[j][i].im;
		rb= b[j][i].re; mb= b[j][i].im;
		a[j][i].re= rb+ra;	// A= B+A
		a[j][i].im= mb+ma;
	}
}
void
root(void)
{
	int i,j;
	double m,r;
	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		r= wk[j][i].re;
		m= wk[j][i].im;
		if(r<0) wk[j][i].re= -sqrt(-r);
		else	wk[j][i].re= sqrt(r);
		if(m<0) wk[i][i].im= -sqrt(-m);
		else	wk[i][i].im= sqrt(m);
	}
}

void
auto_correlation(Mt m[V][H])	// calculate auto correlation function
{
	int i,j,k,l,d;
	double c;
	for(l=0;l<V;l++)
	for(k=0;k<H;k++) {
		double s= 0;
		for(j=U;j<PY-U;j++)
		for(i=M;i<PX-M;i++) s+= in.y[j][i] * in.y[j+l-U][i+k-M];
		m[l][k]= s;
	}
	c= m[U][M];
	for(l=0;l<V;l++)
	for(k=0;k<H;k++) m[l][k]/= c;
}

void
mk_psf2(Mt m[V][H])	// make point spreading function by calc auto_corr and squared
{
	auto_correlation(m);
	mlt(m,m);
	norm1(m,(double)1);
	pr_mat(m);
}
/*
void
mk_psf(Mt m[V][H])	// make point spreading function by calc auto_corr, and root spectrum
{
	auto_correlation(m);
	norm1(m,(double)1);
	pr_mat(m);
	set_wk(wk,m);
	FT(wk);
	root();
	IT(wk);
	prep_fir(wk,m);
	norm1(m,(double)1);
	pr_mat(m);
}
*/

void
peak_pos(int x0, int y0, int *px, int*py, int *pk)
{
	int x,y;
	int max= 160;
	for(y= y0;y<y0+V;y++)
	for(x= x0;x<x0+H;x++) { int d= in.y[y][x]; if(d>max) { max= d; *px= x; *py= y; *pk= max; } }
}

void
get_rect(int x0, int y0, Mt m[V][H], Sif *p)
{
	int x,y;
	for(y= y0-U;y<y0+U;y++)
	for(x= x0-M;x<x0+M;x++) m[y-y0+M][x-x0+M]= p->y[y][x];
}

double
average(Mt m[V][H])
{
	int i,j, sum= 0;

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) sum+= m[j][i];	
	return (double)sum/(V*H);
}

void
draw_line(int x, int y)
{
	int i,j;
	for(i=x-8;i<x+8;i++) in.y[y][i]= 255;
}
void
draw_line2(int x, int y)
{
	int i,j;
	for(i=y-8;i<y+8;i++) in.y[i][x]= 255;
}


int
area(Mt m[V][H])
{
	int i,j,a=0;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) a+= (m[j][i]!=0);
	//printf("%d\n",a);
	return a;
}

int
c1(int i, int j, Mt m[V][H], Mt n[V][H],Mt c, Mt last)
{
	int sum= 0;
	while (i>=0 && i<H && j>=0 && j<V && n[j][i]>=c && n[j][i]<=last+8 && m[j][i]==0){
		last= m[j][i]= n[j][i];
		sum++;
		sum+= c1(i+1,j,m,n,c,last);
		sum+= c1(i,j+1,m,n,c,last);
		sum+= c1(i-1,j,m,n,c,last);
		sum+= c1(i,j-1,m,n,c,last);
	}
	return sum;
}

int
connect1(Mt m[V][H], Mt c)
{
	Mt n[V][H];
	int i,j, r;

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) n[j][i]= m[j][i];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) m[j][i]= 0;

	r= c1(M,M,m,n,c,255);
	return r;
}

void
get_peak(int sx, int sy, Mt m1[V][H], Sif *p)
{
	int i,j,x,y,pk,min=100,t;
	Mt m[V][H];
	Mt c;

	/*
	for(j=V;j<sy-V;j+=V)
	for(i=H;i<sx-H;i+=H) {
		x= y= 0;
		peak_pos(i,j, &x, &y, &pk);
		if((x|y) //&&((p->y[y][x] + p->y[y][x+1] + p->y[y+1][x] + p->y[y+1][x+1] )/4>= 150)
				){
			get_rect(x,y,m,p);
			if((c=average(m))<pk/2) {
				printf("pk(%d %d)pk=%d c=%3.1f ",x,y,pk,c);
				//draw_line(x,y);
				connect1(m,c);
				norm(m,(double)1.);
				pr_mat(m);
				t= area(m);
				if(t<min) {
					min= t; printf("min= %d at(%d %d)\n",min,x,y);
					//draw_line2(x,y);
					cpy(m1,m);
				}
			}
		}
	}
	*/
	strcpy(name,"point");
loop:
	peak_pos_x= peak_pos_y= 0;
	while((x=peak_pos_x)==0 || (y=peak_pos_y)==0){ usleep(100000); wt(&in,name); }
	get_rect(x,y,m,p);
	c= average(m);
	printf("(%d %d) c=%3.1f\n",x,y,c);
	t= connect1(m,c);
	if(t==0) { strcpy(name,"psf is not defined."); goto loop; }
	norm(m,(double)1.);
	pr_mat(m);
	t= area(m);
	if(t<5) { strcpy(name,"too small area, re-point."); goto loop; }
	cpy(m1,m);
}

void
prep_psf(int c, Mt m[V][H],int sx, int sy)	// prepare point spreading function
{
	int i,j,k,l;

	if(c!=2)
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++) {
		dbt d= mat[(j+cy)*H+(i+cx)] - O;
		if (d<0) d= 0;
		d= gamma_(d);
		m[j+U][i+M]= d;
	}
	norm1(m,(double)1);
	//mk_psf2(m);
	//get_peak(sx,sy, m, &in);
#ifdef VSEP
	for(k=0;k<4;k++) {
		for(j=0;j<V;j++)
		for(i=0;i<H;i++) mats[k][U+(j-U)*(5-k)/5][i]+= m[j][i];
		norm(mats[k],(double)1);
	}
#endif
}

/*
**	iir() : IIR inverse filtering
**	 input: p1: degraded, p2: iteration n-1, m: point spread function
**	output: p3: iteration n
*/
void
iir(int sx,int sy, Sif *p1, Sif *p2, Sif *p3, Mt m[V][H])
{
	int i,j,k,l,x1,x2,y1,y2,v;
	double center= -m[V][M]+FP+1.;

	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++){
		double a= center * p1->y[j][i] + 0.5; // center pel is from p1

		x1= -M; if(i+x1< 0) x1= -i;
		x2=  M-1; if(i+x2>sx) x2= sx-i;
		y1= -U; if(j+y1< 0) y1= -j;
		y2=  U-1; if(j+y2>sy) y2= sy-j;	// surrounding area is constranied

		for(l= y1;l<y2;l++)
		for(k= x1;k<x2;k++) if(k|l) a-= p2->y[j-l][i-k] * m[l+U][k+M];
						// from p2 and mat2[][]
		v= a; if(v<0) v= 0; else if(v>255) v= 255; // limit in [0,255]
		p3->y[j][i]= v;
	}
}

/*
**
**	blind deconvolution core
**
*/
//#define SEP
#define TTEST
#define IE(yy,xx)  est[LM(yy,sy)][LM(xx,sx)]

#ifdef SEP
#define IE0(yy,xx)  est0[LM(yy,sy)][LM(xx,sx)]
#else
#define IE0(yy,xx)  IE(yy,xx)
#endif

#ifdef TTEST
#define IEA(a,b,c) (IE(a,b)=MAX(IE(a,b)+c,T))
#else
#define IEA(a,b,c) (IE(a,b)+=c)
#endif
void
fir12(rect *or,int sx,int sy, dbt est[][sx], dbt inp[][sx], int h,int v, Mt m[][h],int lay)
{
	int i,j,k,l=lay; dbt a;
	int ix= ixa[l],ax= axa[l],iy= iya[l],ay= aya[l];
	int x= or->s.x; int ex= or->e.x;
	int y= or->s.y; int ey= or->e.y;
#ifndef FULLP
	x+= ax; ex+= ix; y+= ay; ey+= iy;
#endif
	for(j=y;j<ey;j++)
	for(i=x;i<ex;i++) {
		a= 0;
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) a+= IE(j-l,i-k) * m[l+v/2][k+h/2];
		if(a>1) a= 1;
		inp[j][i]= a;
	}
}
void
iir12(rect *or,int sx,int sy,dbt inp[][sx],dbt err[][sx],dbt rat[][sx], dbt est[][sx], int h,int v,Mt m[][h],int lay)
{
	int i,j,k,l=lay,c,cnt= 0; dbt a,e,s,t,u;
	int ix= ixa[l],ax= axa[l],iy= iya[l],ay= aya[l];
	int x= or->s.x; int ex= or->e.x;
	int y= or->s.y; int ey= or->e.y;
	int ln= v*h, flag= 0;
	Mt b[v][h]; Mt c0[v][h];
#ifndef FULLP
	x+= ax; ex+= ix; y+= ay; ey+= iy;
#endif
lo:	s=t=c= 0;
	clrl((Mt*)c0,ln);
#ifdef SEP
	for(j=y;j<ey;j++) for(i=x;i<ex;i++) est0[j][i]= est[j][i];
#endif
	for(j=y;j<ey;j++)
	for(i=x;i<ex;i++) { a= 0;
		s+= est[j][i];
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) a+= b[l+v/2][k+h/2]= IE0(j-l,i-k) * m[l+v/2][k+h/2];
		//if(a<T) a= T;
		if(a>1) a= 1;
		e= err[j][i]= inp[j][i] - a;
		rat[j][i]= a= e/a; t+= e*e; c++;
#ifdef Damp
		if(use_gamma)
			a*= 2*fabs(a); //for unif or unif2,
			//a*= 4*a*a; //GOOD
			//if(fabs(a)<0.16) a= 0;
			//for LUCY, rat[j][i]= a*= fabs(a); is workable, slows
//{u= a+1.; if(u<T) u= T; u= 1000*(inp[j][i]*log(u)-e); if(u<1.) a*= u*u*u*u*u*u*u*u*u*(10-u*9);}
#endif
#ifdef Unified	// filter and error deliver are concatenated for an error pel 
#define Unif2
#ifdef Unif2
		if(e>0) {
			flag= 1;
			for(l=iy;l<=ay;l++)
			for(k=ix;k<=ax;k++) c0[l+v/2][k+h/2]+= IE0(j-l,i-k)*e*e;
		}
#endif
//#define Unif3
#ifdef Unif3
		a= 1.;
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) a+= m[l+v/2][k+h/2] * rat[LM(j+l,sy)][LM(i+k,sx)];
		est[j][i]*= a;
#else
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) {
			//e= a*b[l+v/2][k+h/2]; IEA(j-l,i-k,e); //c0[l+v/2][k+h/2]+= e;
			if(j-l>=0&&i-k>=0&&j-l<sy&&i-k<sx) est[j-l][i-k]+= a*b[l+v/2][k+h/2];
		}
#endif
	}
#else
	}
//#define Resid
//#define Landweber
#define LUCY
//#define ER3
//#define ER2
//#define ER1
#ifdef ER1 // error deliveration (1) make an PSF size array (2) distibute error using it.
	for(j=y;j<ey;j++)
	for(i=x;i<ex;i++) {
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) b[l+v/2][k+h/2]= IE0(j-l,i-k) * m[l+v/2][k+h/2];
		a= rat[j][i];
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) { e= a*b[l+v/2][k+h/2]; IEA(j-l,i-k,e); c0[l+v/2][k+h/2]+= e; }
	}
#endif
#ifdef ER2 // er2 != er1, if no sep, there are multiple changes of the edge of estimate
	// for an error pel. Error deliveration using PSF*estimate pels surrounding the error pel.
	for(j=y;j<ey;j++)
	for(i=x;i<ex;i++) { a= rat[j][i];
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) {
			e= a*m[l+v/2][k+h/2]*IE0(j-l,i-k); IEA(j-l,i-k,e); c0[l+v/2][k+h/2]+= e;
		}
	}
#endif
#ifdef ER3 // er3 == er2 (c0 differs because, e differs)
	for(j=y;j<ey;j++)
	for(i=x;i<ex;i++) { a= rat[j][i];
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) {
			IE(j-l,i-k)*= (1 + a*m[l+v/2][k+h/2]);
			if(IE(j-l,i-k)<T) IE(j-l,i-k)=T; //c0[l+v/2][k+h/2]+= e;
		}
	}
#endif
#ifdef LUCY
	// * PSF^T,  No error deliveration out of area, No multiple chages of estimate
	// for an error pel. But the edge pels show distinctive artifact
	for(j=y;j<ey;j++)
	for(i=x;i<ex;i++) { a= 1.;
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) a+= m[l+v/2][k+h/2] * rat[LM(j+l,sy)][LM(i+k,sx)];
		est[j][i]*= a;
	}
#endif
#ifdef Resid
	for(j=y;j<ey;j++)
	for(i=x;i<ex;i++) est[j][i]+= err[j][i]*0.05;
#endif
#ifdef Landweber
	for(j=y;j<ey;j++)
	for(i=x;i<ex;i++) { a= 0.;
		for(l=iy;l<=ay;l++)
		for(k=ix;k<=ax;k++) a+= m[l+v/2][k+h/2]*err[LM(j+l,sy)][LM(i+k,sx)];
		est[j][i]+= a;
	}
#endif
#endif
	t/= c;
	if(last_err!=0 && t>last_err && cnt++<4) { avgl((Mt*)m,(Mt*)lastm,ln); printf("bk "); goto lo; }
	last_err= t; cpyl((Mt*)lastm,(Mt*)m,ln);
	if(pre)printf("%d %f\n",lay,sqrt(t));
	if(psfm==2){ mlsl((Mt*)c0,accl/s,ln); addl((Mt*)m,(Mt*)c0,ln); }
	else if(psfm) 
#ifdef Unif2
	if(flag)mltl((Mt*)m,(Mt*)c0,ln);
#else
	for(l=iy;l<=ay;l++)
	for(k=ix;k<=ax;k++) { a= 1E-12; // avoid psf is zero when all err[][]<= 0
		for(j=y;j<ey;j++)
		for(i=x;i<ex;i++)
			if((e= err[j][i])>0) a+= IE(j-l,i-k)*e*e;
		/* bipolar
		for(j=y;j<ey;j++)
		for(i=x;i<ex;i++) { e= err[j][i]; a+= IE(j-l,i-k)*e*e; }
		*/
		//if(lay) a= sqrt(a); //a= sqrt(a); a= sqrt(a);
		m[l+v/2][k+h/2]*= a;
	}
#endif
#ifdef CENT
	cpyl(c0,m,ln);
	centroid2(h,v,m,c0);
#endif
	norm_hir(h,v,m);
}

void
expands(int l, int dv, int dvl,
	int h,  int v,
	int hu, int vu,
	Mt ml[DY][DX][V][H],
	Mt mu[DY][DX][V][H])
{
	int n,m;
	/*
	Mt s[V][H];
	Mt t[V][H];
	Mt u[V][H];
	Mt w[V][H];
	*/
	for(n=0;n<dv;n++)
	for(m=0;m<dv;m++) {
		expand_psf(h,v,hu,vu,ml[n*2][m*2],mu[n][m]);
		cpy(ml[n*2  ][m*2+1],ml[n*2][m*2]);
		cpy(ml[n*2+1][m*2  ],ml[n*2][m*2]);
		cpy(ml[n*2+1][m*2+1],ml[n*2][m*2]);
	}
	/*
	for(n=0;n<dv;n++)
	for(m=0;m<dv;m++) {
		expand_psf(h,v,hu,vu,ml[n*2][m*2],mu[n][m]);

		if(m+1<dv){
			cpy(t,mu[n][m]);
			add(t,mu[n][m+1]);
			expand_psf(h,v,hu,vu,ml[n*2][m*2+1],t);
		} else cpy(ml[n*2  ][m*2+1],ml[n*2][m*2]);

		if(n+1<dv){
			cpy(s,mu[n][m]);
			add(s,mu[n+1][m]);
			expand_psf(h,v,hu,vu,ml[n*2+1][m*2],s);
		} else cpy(ml[n*2+1][m*2  ],ml[n*2][m*2]);

		if(m+1<dv && n+1<dv){
			add(t,mu[n+1][m]);
			add(t,mu[n+1][m+1]);
			expand_psf(h,v,hu,vu,ml[n*2+1][m*2+1],t);
		} else cpy(ml[n*2+1][m*2+1],ml[n*2][m*2]);
	}
	*/
	/*
	for(n=0;n<dv;n++)
	for(m=0;m<dv;m++) { int i,j;
		expand_psf(h,v,hu,vu,s,mu[n][m]);		// s: up-left
		if(m+1<dv) expand_psf(h,v,hu,vu,u,mu[n][m+1]);	// u: right
		else cpy(u,s);
		if(n+1<dv) expand_psf(h,v,hu,vu,t,mu[n+1][m]);	// t: down
		else cpy(t,s);
		sub(u,s); mls(u,1./(dvl*2-1));
		sub(t,s); mls(t,1./(dvl*2-1));
		for(j=0;j<dvl;j++) {
			cpy(w,s);
			for(i=0;i<dvl;i++) { cpy(ml[n*2+j][m*2+i],w); add(w,u); }
			add(s,t);
		}
	}
	*/
}

/*
**	fir() : FIR filter
**	 input: p1, psf: m[][]
**	output: p2
*/
void
fir(int sx,int sy, Sif *p1, Sif *p2,Mt m[V][H])
{
	int i,j,k,l,x1,x2,y1,y2,v;

	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++){
		double a= 0.5;

		x1= -M; if(i+x1< 0) x1= -i;
		x2=  M-1; if(i+x2>sx) x2= sx-i;
		y1= -U; if(j+y1< 0) y1= -j;
		y2=  U-1; if(j+y2>sy) y2= sy-j;

		for(l= y1;l<y2;l++)
		for(k= x1;k<x2;k++) a+= p1->y[j-l][i-k]* m[l+U][k+M];
		//v= sqrt(a);
		v= a;
		if(v<0) v= 0; else if(v>255) v= 255;
		p2->y[j][i]= v;
	}
}

void
fir2(dbt q[Fs][Fs], dbt p[Fs][Fs],Mt m[V][H])
{
	int i,j,k,l,x1,x2,y1,y2;

	for(j=0;j<Fs;j++)
	for(i=0;i<Fs;i++){
		double a= 0.5;
		x1= -M;   if(i+x1< 0) x1= -i;
		x2=  M-1; if(i+x2>Fs) x2= Fs-i;
		y1= -U;   if(j+y1< 0) y1= -j;
		y2=  U-1; if(j+y2>Fs) y2= Fs-j;
		for(l= y1;l<y2;l++)
		for(k= x1;k<x2;k++) a+= p[j-l][i-k] * m[l+U][k+M];
		q[j][i]= a;
	}
}

read_in_yuv_file(int z, char *n)
{
	FILE *f= fopen(n, "rb");
	if(!f) { char na[256]; strcpy(na,n); strcat(na,".yuv"); f= fopen(na,"rb"); }
	if(!f) { fprintf(stderr,"%s ropen err\n", n); exit(1); }
	if(fread(&in,1,z,f)<z) { fprintf(stderr,"%s read err\n",n); exit(1); }
	fclose(f);
}

write_out(int z,char *n)
{
	FILE *f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wopen err\n",n); exit(1); }
	if(fwrite(&ot,1,z,f)<z) { fprintf(stderr,"%s write err\n",n); exit(1); }
	fclose(f);
}

read_psf(char *n, Mt m[V][H])
{
	FILE *f= fopen(n, "rb"); if(!f) { fprintf(stderr,"%s ropen err\n",n); exit(1); }
	if(fread(m,1,sizeof(Mt)*V*H,f)<sizeof(Mt)*V*H) { fprintf(stderr,"%s read err\n",n); exit(1); }
	fclose(f);
}

Mt c[V*2][H*2];

read_exp_psf(char *n, Mt m[V][H])
{
	int i,j,x,y;
	Mt a[V/2][H/2];
	Mt b[V][H];
	Mt cx,cy,sm,d;
	FILE *f= fopen(n, "rb"); if(!f) { fprintf(stderr,"%s ropen err\n",n); exit(1); }
	if(fread(a,1,sizeof(Mt)*V*H/4,f)<sizeof(Mt)*V*H/4) { fprintf(stderr,"%s read err\n",n); exit(1); }
	fclose(f);

	for(j=0;j<V/2;j++)
	for(i=0;i<H/2;i++) b[j*2  ][i*2  ]= b[j*2  ][i*2+1]= b[j*2+1][i*2  ]= b[j*2+1][i*2+1]= a[j][i];

	cx=0; cy=0;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) { d= b[j][i]; cx+= d*(i-M); cy+= d*(j-U); sm+= d; }
	x= cx/sm;
	y= cy/sm;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) c[j-y+V][i-x+H]= b[j][i];

	for(j=0;j<V-1;j++)
	for(i=0;i<H-1;i++) m[j][i]= (c[j+V][i+H] + c[j+V][i+H+1] + c[j+V+1][i+H] + c[j+V+1][i+H+1])/4;
}

write_psf(char *n, Mt m[V][H])
{
	FILE *f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wopen err\n",n); exit(1); }
	if(fwrite(m,1,sizeof(Mt)*V*H,f)<sizeof(Mt)*V*H) { fprintf(stderr,"%s write err\n",n); exit(1); }
	fclose(f);
}

void
pr_trace(void)
{
int i;
for(i=0;i<N;i++){ if(i%H==0) printf("\n"); printf("%7.4f ",matrix[i][i+N]); } printf("\n");
}

void
rnd_pel(int sx,int sy, Sif *p)
{
	int i,j;
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++)p->y[j][i]= rand()&255;
}

void
mult_mat( Mt a[N], Mt b[N])
{
	int i,j;
	for(j=0;j<N;j++) {
		double s= 0;
		for(i=0;i<N;i++) s+= matrix[j][i+N]*a[i];
		b[j]= s;
	}
}
void
mult_mat_sk( Mt a[N], Mt b[N])
{
	int i,j;
	for(j=0;j<N-1;j++) {
		double s= 0;
		for(i=0;i<N-1;i++) s+= matrix[j][i+N]*a[skip_center(i)];
		//for(i=0;i<N-1;i++) { int k= skip_center(i); s+= matrix[j][k+N]*a[k]; }
		b[skip_center(j)]= s;
	}
	b[Center]= 0;
}
void minus_mat(Mt a[N]) { int i; for(i=0;i<N;i++)a[i]= -a[i]; }


void prep_mat(Mt m[V][H]) {
	m[0][0]= 0;
	m[0][M-1]= 0;
	m[0][H-1]= 0;

	m[U-1][0]= 0;
	m[U-1][M-1]= 0;
	m[U-1][H-1]= 0;

	m[V-1][0]= 0;
	m[V-1][M-1]= 0;
	m[V-1][H-1]= 0;
	/*
	int i,j;
	double sum=0;
	Mt s[V][H];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) s[j][i]=0;

	for(j=1;j<V;j++)
	for(i=1;i<H;i++) s[j][i]= m[j-1][i-1];

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) { int r2= (i-M)*(i-M)+ (j-U)*(j-U); sum+= s[j][i]*= exp(-r2/32.); }

	for(j=0;j<V;j++)
	for(i=0;i<H;i++) m[j][i]= s[j][i]/sum;
	*/
}

void
gaussian(Mt s[V][H],dbt rad) { int i,j;
	rad*= rad;
	for(j=0;j<V;j++) for(i=0;i<H;i++) { int r2= (i-M)*(i-M)+(j-U)*(j-U); s[j][i]= 
		//(1-r2/64.)*
			exp(-r2/rad); }
	norm(s,(double)1);
}

void
angle_psf(Mt s[V][H],dbt d) { int i,j;

	for(j=0;j<V;j++) for(i=0;i<H;i++) s[j][i]= 1E-6;
	j=V/2; for(i=H/2-d;i<H/2+d;i++) s[j][i]= 1;
	i=H/2; for(j=V/2-d;j<V/2+d;j++) s[j][i]= 1;
	norm(s,(double)1);
}


Mt b[V][H];

rev(Mt a[V][H]) {
	int i,j;
	for(j=0;j<V;j++) for(i=0;i<H;i++) b[j][i]= a[V-1-j][H-1-i];
	for(j=0;j<V;j++) for(i=0;i<H;i++) a[j][i]= b[j][i];
}

#ifdef INV_MAT
void
get_mat_fir(int sx, int sy, int x, int y)
{
	get_mat(mat3, x, y);
	norm(mat3,(double)1);
	//pr_mat(mat3);
	fir(sx,sy,&in,&ot,mat3);
}
#endif

rect rect1;

void
mk_rect()
{
	int x,y;
	peak_pos_x= 0;
	peak_pos_y= 0;
	while(peak_pos_x==0 && peak_pos_y==0) { wt(&ot,"set upper left corner"); usleep(100000); }
	rect1.s.x= peak_pos_x;
	rect1.s.y= peak_pos_y;

	peak_pos_x= 0;
	peak_pos_y= 0;
	while(peak_pos_x==0 && peak_pos_y==0) { wt(&ot,"set lower right corner"); usleep(100000); }
	rect1.e.x= peak_pos_x;
	rect1.e.y= peak_pos_y;

	/*
	hline(rect1.s.y, rect1.s.x, rect1.e.x);
	hline(rect1.e.y, rect1.s.x, rect1.e.x);
	vline(rect1.s.x, rect1.s.y, rect1.e.y);
	vline(rect1.e.x, rect1.s.y, rect1.e.y);
	grid= 1;
	*/
}

void
sub_rect(rect *a, rect *b) {
	a->s.x-= b->s.x;
	a->s.y-= b->s.y;
	a->e.x-= b->s.x;
	a->e.y-= b->s.y;
}

void
init_psfa(void) {
	int i,j,k,l;
	for(l=0;l<DY;l++)
	for(k=0;k<DX;k++)
	for(j=0;j< V;j++)
	for(i=0;i< H;i++) psfa[l][k][j][i]= (1./(V*H));
}

void
avg_est(int sx, int sy)
{
	int i,j;
	dbt a= 0;
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++) a+= est[j][i];
	a/= sx*sy;
#ifdef FULLP
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++) est[j][i]= a;
#else
	for(j=ay;j<sy+iy;j++)
	for(i=ax;i<sx+ix;i++) est[j][i]= a;
#endif
}
void
avg_est_l1(int sx, int sy, int lay)
{
	int c,i,j,k,l=lay; int ix= ixa[l],ax= axa[l],iy= iya[l],ay= aya[l];
	dbt a= 0;
	sx>>=l; sy>>=l;

	switch(lay){
	case 0:
		for(j=0;j<sy;j++)
		for(i=0;i<sx;i++) { a= c= 0;
			for(l=iy;l<=ay;l++) for(k=ix;k<=ax;k++)
				if(j-l>=0&&i-k>=0&&j-l<sy&&i-k<sx) { a+= est[j-l][i-k]; c++; }
			flt[j][i]= a/c;
		}
		cp(est,flt); break;
	case 1:
		for(j=0;j<sy;j++)
		for(i=0;i<sx;i++) { a= c= 0;
			for(l=iy;l<=ay;l++) for(k=ix;k<=ax;k++)
				if(j-l>=0&&i-k>=0&&j-l<sy&&i-k<sx) { a+= est2[j-l][i-k]; c++; }
			flt2[j][i]= a/c;
		}
		cp(est2,flt2); break;
	case 2:
		for(j=0;j<sy;j++)
		for(i=0;i<sx;i++) { a= c= 0;
			for(l=iy;l<=ay;l++) for(k=ix;k<=ax;k++)
				if(j-l>=0&&i-k>=0&&j-l<sy&&i-k<sx) { a+= est3[j-l][i-k]; c++; }
			flt3[j][i]= a/c;
		}
		cp(est3,flt3); break;
	case 3:
		for(j=0;j<sy;j++)
		for(i=0;i<sx;i++) { a= c= 0;
			for(l=iy;l<=ay;l++) for(k=ix;k<=ax;k++)
				if(j-l>=0&&i-k>=0&&j-l<sy&&i-k<sx) { a+= est4[j-l][i-k]; c++; }
			flt4[j][i]= a/c;
		}
		cp(est4,flt4); break;
	case 4:
		for(j=0;j<sy;j++)
		for(i=0;i<sx;i++) { a= c= 0;
			for(l=iy;l<=ay;l++) for(k=ix;k<=ax;k++)
				if(j-l>=0&&i-k>=0&&j-l<sy&&i-k<sx) { a+= est5[j-l][i-k]; c++; }
			flt5[j][i]= a/c;
		}
		cp(est5,flt5);
	}
}

void
avg_est_l(int sx, int sy, int l)
{
	int i,j; int ix= ixa[l],ax= axa[l],iy= iya[l],ay= aya[l];
	dbt a= 0;
	sx>>=l; sy>>=l;
#ifdef FULLP
	ix= iy= ax= ay= 0; 
#endif
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++) switch(l) {
		case 0: a+= est [j][i]; break;
		case 1: a+= est2[j][i]; break;
		case 2: a+= est3[j][i]; break;
		case 3: a+= est4[j][i]; break;
		case 4: a+= est5[j][i]; break;
	}
	a/= sx*sy;
	for(j=ay;j<sy+iy;j++)
	for(i=ax;i<sx+ix;i++) switch(l) {
		case 0: est [j][i]= a; break;
		case 1: est2[j][i]= a; break;
		case 2: est3[j][i]= a; break;
		case 3: est4[j][i]= a; break;
		case 4: est5[j][i]= a; break;
	}
}

void
avg_est_ld(rect *or, int sx, dbt est[][sx])
{
	int x,y,ex,ey, cnt= 0;
	dbt sum= 0;
	for(y= or->s.y;y<or->e.y;y++)
	for(x= or->s.x;x<or->e.x;x++) { sum+= est[y][x]; cnt++; }
	if(sum==0)sum= 1E-8;
	sum/= cnt;
	for(y= or->s.y;y<or->e.y;y++)
	for(x= or->s.x;x<or->e.x;x++) est[y][x]= sum;
}

void
sub_add_img(Sif *p,Sif *q,Sif *r,int sx, int sy)
{
	int i,j;
	for(j=0;j<sy;j++)
	for(i=0;i<sx;i++) {
		int d= p->y[j][i] + q->y[j][i] - r->y[j][i];
		if(d<0)d=0; if(d>255)d=255;
		p->y[j][i]= d;
	}
}

Mt m22[V2][H2];
Mt m23[V3][H3];
Mt m24[V4][H4];
Mt m25[V5][H5];
void
expand_disp(int l, rect *or, rect *ir)
{
	if(expd){
		if(l==4)expand_direct(4,tmp,est5);
		else if(l==3)expand_direct(3,tmp,est4);
		else if(l==2)expand_direct(2,tmp,est3);
		else if(l==1)expand_direct(1,tmp,est2);
		else if(l==0)expand_direct(0,tmp,est);
		dbl2sif(or,ir,EX,tmp,ot.y);
	} else {
		if(l>=4) expand_img(EX/8,EY/8,est4,est5);
		if(l>=3) expand_img(EX/4,EY/4,est3,est4);
		if(l>=2) expand_img(EX/2,EY/2,est2,est3);
		if(l>=1) expand_img(EX,EY,est, est2);
		dbl2sif(or,ir,EX,est,ot.y);
	}
}

Mt m3[HIR][DY][DX][V][H];
Mt m3l[DX][V][H];

clr_wk(complex w[Fs][Fs]) { int i,j; for(j=0;j<Fs;j++) for(i=0;i<Fs;i++) w[j][i].re= w[j][i].im= 0; }
set_wk(complex w[Fs][Fs], Mt m[][H]){
	int i,j;
	dbt sum= 0;


	//for(j=0;j<V;j++)
	//for(i=0;i<H;i++) w[j][i].re= m[j][i];
	//
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) sum+= m[j][i];
	printf("%f\n",sum);


	for(j=0;j<V/2;j++){
		for(i=0;i<H/2;i++) w[Fs-V/2+j][Fs-H/2+i].re= m[j][i];
		for(i=H/2;i<H;i++) w[Fs-V/2+j][i-H/2].re= m[j][i];
	}

	for(j=V/2;j<V;j++){
		for(i=0;i<H/2;i++) w[-V/2+j][Fs-H/2+i].re= m[j][i];
		for(i=H/2;i<H;i++) w[-V/2+j][i-H/2].re= m[j][i];
	}
}

void
clip_est(complex w[Fs][Fs]){
	int i,j;
	for(j=0;j<SY;j++)
	for(i=0;i<SX;i++) {
		w[j][i].im= 0;
		if(w[j][i].re<0)w[j][i].re= 0;
	}
}

void
clip_psf(complex w[Fs][Fs]){
	int i,j;
	dbt sum= 0;
	for(j=0;j<SY;j++)
	for(i=0;i<SX;i++) {
		if(w[j][i].re<0)w[j][i].re= 0;
		sum+= w[j][i].re;
		w[j][i].im= 0;
	}
	for(j=0;j<SY;j++)
	for(i=0;i<SX;i++) w[j][i].re/= sum;
}
Mt le[DY][DX];

//-- deconvolution function --
void
deconv(int sx, int sy, int ex, int ey, int sz, Mt m2[V][H])
{
	int k,x,y;
	rect ir,or,of;// of= ir - or;

#ifdef TST
	norm(m2,(double)1);
	pr_mat(m2);
	memcpy(&ot,&in,sz);
	getchar();
	for(k=0;k<iloop;k++){
		fir(ex,ey,&ot,&ou,m2);	// filter ot ==> ou
		sub_add_img(&ot,&in,&ou,ex,ey);	// ot+= (in - ou)
		sprintf(name,"%d",k); wt(&ot,name);
		getchar();
	}
	/*
	//rev(m2);
	norm(m2,(double)-1);
	m2[U][M]+= 2;
	pr_mat(m2);
	for(k=0;k<iloop;k++){
		printf("%d",k);
		sprintf(name,"%d",k);
		fir(ex,ey,&in,&ot,m2);
		wt(&ot,name);
		memcpy(&in,&ot,sz);
		getchar();
	}
	*/
	//norm(m2,(double)-1); m2[U][M]+= 2; pr_mat(m2); fir(sx,sy,&in,&ot,m2);
	//gaussian(mat3,8); sub(m2,mat3); m2[U][M]+= 1; pr_mat(m2); fir(sx,sy,&in,&ot,m2);
#endif
#ifdef LPC
	//auto_correlation(m2);
	norm(m2,(double)1);
	pr_mat(m2);
	put_mat_sk(m2); inv_mat(N-1,N*2-1);	// skip-center setting to N-1 x (2N-1) matrix 
	mult_mat_sk((Mt*)m2,(Mt*)mat3);	// inversed matrix x m2 ==> mat3 (with skipping center)
	prep_mat(mat3);				// to remove 8 point big values
	norm(mat3,(double)-1);
	pr_mat(mat3);
	mat3[U][M]+= 2; pr_mat(mat3); fir(ex,ey,&in,&ot,mat3);
	wt(&ot,"in.yuv");
	getchar();
#endif
#ifdef INV_MAT
	x= y= -1;
	put_mat(m2); inv_mat(N,N*2);
	do{
		if(x!=xoff||y!=yoff) {
			x= xoff;
			y= yoff;
			sprintf(name,"x= %d, y= %d",x,y);
			get_mat_fir(ex,ey,x,y);
		}
		wt(&ot,name);
	}while(1);
#endif
#ifdef Wiener
	gaussian(m2,3);
	pr_mat(m2); or.s.x= or.s.y= 0; or.e.x= ex; or.e.y= ey; ir= or;

	clr_wk(wpsf); set_wk(wpsf,m2); FT(wpsf);
	sif2dbl(&ir,EX,in.y,inp);
	clr_wk(wk); set_fft(wk,inp); FT(wk);
	divd(wk,wk,wpsf);
	IT(wk); get_fft(wk,est);
	dbl2sif(&or,&ir,ex,est,ot.y); sprintf(name,"Wiener result"); wt(&ot,name);
	getchar();

	/*
	clr_wk(wk); set_wk(wk,m2);
	FT(wk); rv(wk); IT(wk);
	get_wk(m2,wk); norm(m2,(double)1.0); pr_mat(m2);
	*/

	/*
	norm(m2,(double)0.2);
	fir2(est,inp,m2);
	*/

	/*
	clr_wk(wpsf); set_wk(wpsf,m2); FT(wpsf);
	clr_wk(wk); set_fft(wk,inp); FT(wk);
	mult(wk,wpsf,wk);
	IT(wk); get_fft(wk,est);

	dbl2sif(&or,&ir,ex,est,ot.y); sprintf(name,"Inv PSF mult result"); wt(&ot,name);
	getchar();
	*/
#endif

#ifdef WienerL
	pr_mat(m2); or.s.x= or.s.y= 0; or.e.x= ex; or.e.y= ey; ir= or;

	clr_wk(wpsf); set_wk(wpsf,m2); FT(wpsf);// PSF is made
	sif2dbl(&ir,EX,in.y,inp);
	clr_wk(winp); set_fft(winp,inp); 	// inp is made
#define WL1
#ifdef WL1
	FT(winp);			// INP
#else
	cp(west,winp); FT(west);	// EST
#endif
	for(k=0;k<iloop;k++){
	  mult(wk,west,wpsf);		// wk= EST*PSF
#ifdef WL1
	  msub(wk,winp);		// wk= INP - wk
	  if(k&1)mda(wpsf,wk,west,1);	// PSF+= wk/EST
	  else   mda(west,wk,wpsf,1);	// EST+= wk/PSF
	  cp(wk,west); IT(wk); clip_est(wk); get_fft(wk,est);
	  //FT(wk); cp(west,wk);
	  //IT(wpsf); clip_psf(wpsf); FT(wpsf);
	  //wpsf[0][0].re= 1.;
#else
	  IT(wk); divd(wk,winp,wk); FT(wk); // wk= inp/wk
	  cp(wx,wk); divd(wk,wk,wpsf); divd(wx,wx,west);// WK/= PSF,WX/= EST
	  IT(wk); IT(west); mult(west,wk,west); get_fft(west,est); FT(west); //est*= wk
	  IT(wx); IT(wpsf); mult(wpsf,wx,wpsf); /*mnorm(wpsf);*/ FT(wpsf); //psf*= wx
#endif
	  dbl2sif(&or,&ir,ex,est,ot.y); sprintf(name,"WienerL %d",k+1); wt(&ot,name);
	  printf("%d: %f\n",k+1,wpsf[0][0].re);
	}

#endif

#ifdef IIR
	getchar();
	norm(m2,(double)FP);
	for(k=0;k<iloop;k++){
		memcpy(&ou,&ot,sz);
		iir(ex, ey, &in, &ou, &ot, m2);
		sprintf(name,"%d\n",k); wt(&ot,name);
		getchar();
	}
#endif
#ifdef IIR1
	{
	int l,c, v[5]={V,V2,V3,V4,V5}, h[5]={H,H2,H3,H4,H5};
	Mt *mp[5]= {(Mt*)m2, (Mt*)m22, (Mt*)m23, (Mt*)m24, (Mt*)m25};
	Mt *ip[5]= {(Mt*)inp,(Mt*)inp2,(Mt*)inp3,(Mt*)inp4,(Mt*)inp5};
	Mt *sp[5]= {(Mt*)est,(Mt*)est2,(Mt*)est3,(Mt*)est4,(Mt*)est5};
	Mt *s0[5]= {(Mt*)est0,(Mt*)est20,(Mt*)est30,(Mt*)est40,(Mt*)est50};
	Mt *ep[5]= {(Mt*)err,(Mt*)err2,(Mt*)err3,(Mt*)err4, (Mt*)err5};
	Mt *rp[5]= {(Mt*)rat,(Mt*)rat2,(Mt*)rat3,(Mt*)rat4, (Mt*)rat5};

	if(gpsf){ while(peak_pos_x==0){ wt(&in,"get_psf"); usleep(100000); } avge= 1; }
	norm(m2,(double)1);
	or.s.x= or.s.y= 0;
	or.e.x= ex; or.e.y= ey;
	ir= or;
	sif2dbl(&ir,EX,in.y,inp);
	//sif2x(&ir,EX,&in,inp);
	cp(est,inp);
#ifdef GAUSS
	gaussian(m2,GAUSS);
	//angle_psf(m2,6);
	l= 0; fir12(&or,ex>>l,ey>>l,sp[l],ip[l],h[l],v[l],mp[l],l);
	cp(est,inp);
	expand_disp(l,&or,&ir);
	wt(&ot,name);
	{
		FILE *fp= fopen("zz.yuv","wb");
		fwrite(&ot,1,sizeof(Sif),fp);
		fclose(fp);
	}
	getchar();
	gpsf= 0;
	psfm= 1;
#endif
	for(l=1;l<HIR;l++) {
		shrink_img(ex>>l,ey>>l,ip[l],ip[l-1]);
		shrink_img(ex>>l,ey>>l,sp[l],sp[l-1]);
		if(gpsf)shrink_psf(h[l],v[l],h[l-1],v[l-1],mp[l],mp[l-1]);
	}
	if(!gpsf)flat_psf(mp[l-1],v[l-1]*h[l-1]);
	while(--l>=0) {
		int lp= (l)?HLP:iloop;
		if(avge)avg_est_l(ex,ey,l);
		last_err= 0;
		or.e.x= ex>>l;
		or.e.y= ey>>l;
		for(k=0;k<lp;k++) {
			iir12(&or,ex>>l,ey>>l,ip[l],ep[l],rp[l],sp[l],h[l],v[l],mp[l],l);
			expand_disp(l,&or,&ir); sprintf(name,"Layer= %d: Iter= %d",l,k+1);
			wt(&ot,name);
			printf(" %s ",name);
		}
		if(l)expand_psf(h[l-1],v[l-1],h[l],v[l],mp[l-1],mp[l]);
	}
	// for chroma
	l= 1;
	ir.e.x= ex>>l; ir.e.y= ey>>l;
	or= ir;
	use_gamma= psfm= 0;	// chroma no gamma and no psf motion
	for(c=0;c<2;c++){
		sif2dbl(&ir,ex>>l,in.c[c],inp2);
		cp(est2,inp2);
		if(avge)avg_est_l(ex,ey,l);
		shrink_psf(h[l],v[l],h[l-1],v[l-1],mp[l],mp[l-1]);
		last_err= 0;
		for(k=0;k<20;k++) {
			iir12(&or,ex>>l,ey>>l,ip[l],ep[l],rp[l],sp[l],h[l],v[l],mp[l],l);
			dbl2sif(&or,&ir,ex>>l,est2,ot.c[c]); sprintf(name,"Chroma %d",k+1);
			wt(&ot,name);
		}
	}
	}

#endif

#ifdef IIR2
	init_psfa();
#ifdef GE
	sif2g_est(&in,inp);
	sif2g_est(&in,est);
	if(avge)avg_est(ex,ey);
#endif

#ifdef FULL
	if(gpsf){ while(peak_pos_x==0){ wt(&in,"get_psf"); usleep(100000); } avge= 1; }
	or.s.x= or.s.y= 0;
	or.e.x= SX; or.e.y= SY;		// or: full image
	ir= or;
	ir.s.x+= M; ir.e.x-= M;
	ir.s.y+= U; ir.e.y-= U;		// ir: inside rect
	of= ir; sub_rect(&of,&or);	// of: ir - or
	iir2(0,0,0,&or,&ir,&of,m2);
#endif

// point rectangles
#ifdef PART
	flat_psf((Mt*)m2,V*H);
	while(1){
	mk_rect();
	ir= or= rect1;
	or.s.x-= M; or.e.x+= M;		// or: outside rect
	or.s.y-= U; or.e.y+= U;
	of= ir; sub_rect(&of,&or);	// of: ir - or
	iir2(0,0,0,&or,&ir,&of,m2);
	}
#endif

// divide image
#ifdef DIVD
	{
	Mt m[V][H]; int i,j,o;
	cpy(m,m2); cpy(psfa[0][0],m);


	for(o=0;o<OLOP;o++) {
	for(j=0;j<DY;j++) {
	for(i=0;i<DX;i++) {
		or.s.x= i*SX/DX; if(i==DX-1) or.e.x= ex; else or.e.x= or.s.x+SX/DX;
		or.s.y= j*SY/DY; if(j==DY-1) or.e.y= ey; else or.e.y= or.s.y+SY/DY;
		ir= or;
#ifdef GE
		if(i==0) ir.s.x+= M; if(i==DX-1) ir.e.x-= M;	// ir: inside of or
		if(j==0) ir.s.y+= U; if(j==DY-1) ir.e.y-= U;	// on the edges of full
#else
		// or: outside of ir, when over edge, it is retrieved, and ir is shrinked
		or.s.x-= M; if(or.s.x< 0) { or.s.x= 0; ir.s.x= M; }
		or.s.y-= U; if(or.s.y< 0) { or.s.y= 0; ir.s.y= U; }
		or.e.x+= M; if(or.e.x>ex) { or.e.x= ex; ir.e.x= ex-M; }
		or.e.y+= U; if(or.e.y>ey) { or.e.y= ey; ir.e.y= ey-U; }
#endif
		if(gpsf){ while(peak_pos_x==0){ wt(&in,"get_psf"); usleep(100000); } peak_pos_x= 0; cpy(m,m2); avge= 1; }
		else {
			//cpy(m,m2);
			if(j&&i==0) cpy(m,m2);
			if(j) avg(m,psfa[j-1][i]);
			if(o){
				if(i<DX-1) avg(m,psfa[j][i+1]);
				if(j<DY-1) avg(m,psfa[j+1][i]);
				avg(m,psfa[ j][ i]);
			}
		}
		of= ir; sub_rect(&of,&or);	// of: ir - or
		if(iir2(o,i,j,&or,&ir,&of,m)) break ;
		//centroid(0,0,0,0,m);
		cpy(psfa[j][i],m);
	}}
	//write_out_psf_jpg(o, name, m);
	}
	}	
#endif
#endif
#ifdef IIR3
	{
	int l, v[5]={V,V2,V3,V4,V5}, h[5]={H,H2,H3,H4,H5};
	Mt *ip[5]= {(Mt*)inp,(Mt*)inp2,(Mt*)inp3,(Mt*)inp4,(Mt*)inp5};
	Mt *sp[5]= {(Mt*)est,(Mt*)est2,(Mt*)est3,(Mt*)est4,(Mt*)est5};
	Mt *s0[5]= {(Mt*)est0,(Mt*)est20,(Mt*)est30,(Mt*)est40,(Mt*)est50};
	Mt *ep[5]= {(Mt*)err,(Mt*)err2,(Mt*)err3,(Mt*)err4,(Mt*)err5};
	Mt *rp[5]= {(Mt*)rat,(Mt*)rat2,(Mt*)rat3,(Mt*)rat4,(Mt*)rat5};
	int xw= ex>>(HIR-1);
	int yw= ey>>(HIR-1);
	int dv= 1;

	if(gpsf){ while(peak_pos_x==0){ wt(&in,"get_psf"); usleep(100000); } avge= 1; }

	norm(m2,(double)1);
	or.s.x= or.s.y= 0;
	or.e.x= ex; or.e.y= ey;
	ir= or;
	sif2dbl(&ir,EX,&in.y,inp);
	cp(est,inp);

	for(l=1;l<HIR;l++) {
		shrink_img(ex>>l,ey>>l,ip[l],ip[l-1]);
		shrink_img(ex>>l,ey>>l,sp[l],sp[l-1]);
		if(gpsf)shrink_psf(h[l],v[l],h[l-1],v[l-1],m3[l],m3[l-1]);
	}
	if(!gpsf) flat_psf(m3[l-1][0][0],v[l-1]*h[l-1]);

	while(--l>=0) { // hierarchical divisional (up to down)
		int lp= (l)?HLP:iloop;
		int m,n,d;
		int ln= v[l]*h[l];
		if(avge&&!part)avg_est_l(ex,ey,l); //<- this is average of all image
		for(k=0;k<lp;k++)
		for(or.s.y= n= 0; n<dv; n++, or.s.y+= yw) 
		for(or.s.x= m= 0; m<dv; m++, or.s.x+= xw) {
			if(prm) printf("%d (%d, %d)\n", k, n,m);
			or.e.x= or.s.x + xw;
			or.e.y= or.s.y + yw;
			if(!k) { le[n][m]= 0; if(avge&&part) avg_est_ld(&or,ex>>l,sp[l]); }
			last_err= le[n][m];
			iir12(&or,ex>>l,ey>>l,ip[l],ep[l],rp[l],sp[l],h[l],v[l],m3[l][n][m],l);
			le[n][m]= last_err;
			expand_disp(l,&or,&ir); sprintf(name,"Layer= %d: (%d, %d) Iter= %d",l,n,m,k+1); wt(&ot,name);
		}
		if(l<HIR-1) // rearrange PSFs
		for(n=0;n<dv;n++)
		for(m=0;m<dv;m++) {
			int c=0; Mt t[V][H];
			clr(t);
			if(m >  0){ addl((Mt*)t,(Mt*)m3[l][n][m-1],ln); c++; }	// left
			if(n >  0){ addl((Mt*)t,(Mt*)m3[l][n-1][m],ln); c++; cpy(m3[l][n-1][m],m3l[m]); } // up
			if(m+1<dv){ addl((Mt*)t,(Mt*)m3[l][n][m+1],ln); c++; }	// right
			if(n+1<dv){ addl((Mt*)t,(Mt*)m3[l][n+1][m],ln); c++; }	// down
			cpy(m3l[m],m3[l][n][m]);		// psf to lb
			intpl((Mt*)m3l[m],(Mt*)t,0.75/c,ln);
			if(prm)printf("rearrange psf %d(%d %d)\n",l,n,m);
			norm_hir(h[l],v[l],m3l[m]);
		}
		if(l) expands(l, dv, 2, h[l-1], v[l-1], h[l], v[l], m3[l-1], m3[l]);
		dv*= 2;
	}
	// for chroma
	{ int c,m,n;
	l= 1; dv/= 4;
	ir.e.x= ex>>l; ir.e.y= ey>>l;
	or= ir;
	use_gamma= psfm= 0;	// chroma no gamma and no psf motion
	for(c=0;c<2;c++){
		sif2dbl(&ir,ex>>l,in.c[c],inp2);
		cp(est2,inp2);
		if(avge)avg_est_l(ex,ey,l);
		for(n= 0; n<dv; n++) 
		for(m= 0; m<dv; m++) shrink_psf(h[l],v[l],h[l-1],v[l-1],m3[l][n][m],m3[l-1][n][m]);

		for(k=0;k<20;k++)
		for(or.s.y= n= 0; n<dv; n++, or.s.y+= yw) 
		for(or.s.x= m= 0; m<dv; m++, or.s.x+= xw) {
			last_err= 0;
			or.e.x= or.s.x + xw;
			or.e.y= or.s.y + yw;
			iir12(&or,ex>>l,ey>>l,ip[l],ep[l],rp[l],sp[l],h[l],v[l],m3[l][n][m],l);
			dbl2sif(&or,&ir,ex>>l,est2,ot.c[c]); sprintf(name,"Chroma %d",k+1); wt(&ot,name);
		}
	
	}
	}
	}
#endif
}

void
cut_out(char *n,int sx,int sy, int d,int e)
{
	int i,j,c,ex= sx+d,ey= sy+e;
	FILE *f= fopen(n, "wb"); if(!f) { fprintf(stderr,"%s wo err\n",n); exit(1); }
	for(j=sy;j<ey;j++)
	 if(fwrite(&ot.y[j][sx],1,d,f)<d) { fprintf(stderr,"%s wr err\n",n); exit(1); }
	sx/=2; sy/=2; ey/=2; d/=2;
	for(c=0;c<2;c++) for(j=sy;j<ey;j++)
	 if(fwrite(&ot.c[c][j][sx],1,d,f)<d) { fprintf(stderr,"%s wr err\n",n); exit(1); }
	fclose(f);
}


void
init_flat(Uc *mat)
{
	int i,j;
	for(j=iy;j<=ay;j++)
	for(i=ix;i<=ax;i++)mat[(j+U)*H+i+M]= 1;
}

void
get_psf(int x, int y)
{
	int i,j;
	for(j=0;j<V;j++)
	for(i=0;i<H;i++) mat2[j][i]= gamma_((dbt)in.y[y+j-U][x+i-M]);
	norm1(mat2,(double)1.);
	printf("get_psf: at (%d,%d).\n",x,y);
}

void
readin_psf(char *n)
{
	int i,j,d,x=0,y=0;
	FILE *f= fopen(n,"r");
	if(!f) { fprintf(stderr,"cant read %s\n",n); exit(1); }
	fscanf(f,"%d %d", &x, &y);
	if(x!=H||y!=V) { fprintf(stderr,"psf mismatch\n",n); exit(1); }
	printf("%d x %d\n",x,y);

	for(j=0;j<y;j++) {
	for(i=0;i<x;i++) {
		fscanf(f,"%d",&d);
		printf("%d ",d);
		mat2[j][i]= d+0.25;
	}
	printf("\n");
	}
	printf("readin PSF: %s OK\n",n);
}

draw_rect(int x,int y,int h,int v) {
	int i,j;
	j= y;   for(i=x;i<=x+h;i++)ot.y[j][i]= 255;
	j= y+v; for(i=x;i<=x+h;i++)ot.y[j][i]= 255;
	i= x;   for(j=y;j<=y+v;j++)ot.y[j][i]= 255;
	i= x+h; for(j=y;j<=y+v;j++)ot.y[j][i]= 255;
}

//-- usage and main --
void
usage(char *c) {
	fprintf(stderr,
	"usage: %s [size_x size_y] file.yuv\n (size_x <= %d, size_y <= %d) \n",
	c,SX,SY); exit(1);
}


int
main(int c, char **v)
{
	int sx=SX,sy=SY,sz= sizeof(Sif);
	char *cm= *v;

	init_flat(mat);

	c--; v++;
	while(c){
		     if(strncmp(*v,"-e",2)==0) estm= atoi(*v+2);
		else if(strncmp(*v,"-p",2)==0) psfm= atoi(*v+2);
		else if(strncmp(*v,"-a",2)==0) accl= atoi(*v+2);
		else if(strncmp(*v,"-l",2)==0) iloop= atoi(*v+2);
		else if(strncmp(*v,"-i",2)==0) avge= atoi(*v+2);
		else if(**v=='-'){
			fprintf(stderr,"unknown option:%d\n",*v);
			usage(cm);
		}
		else break;
		c--; v++;
	}

	if(c==3) {
		sx= atoi(*v++); if(sx>SX) usage(cm);
		sy= atoi(*v++); if(sy>SY) usage(cm);
	} else if(c==2) read_exp_psf(*v++,mat2);
			//read_psf(*v++,mat2);
			//readin_psf(*v++);
	else if(c!=1) usage(cm);

	read_in_yuv_file(sz,*v);

	iwt(name,&in,sx,sy);
	wt(&in,name);
	prep_psf(c,mat2,sx,sy);

	memcpy(&ot,&in,sz);
	memcpy(&ou,&in,sz);
	/*
	cut_out("in1.yuv",0,200,512,512);
	cut_out("in2.yuv",0,600,512,512);
	cut_out("in3.yuv",800,600,512,512);
	cut_out("in4.yuv",1600-512,1200-512,512,512);
	cut_out("in5.yuv",160,120,1024,560);
	cut_out("in6.yuv",400,300,400,400);
	cut_out("inc.yuv",0,200,400,400);
	cut_out("in0.yuv",128,12,256,256);
	cut_out("in0.yuv",152,216,256,256);
	cut_out("ina.yuv",200,400,512,512);
	cut_out("ina2.yuv",100,300,512,512);
	cut_out("ina3.yuv",500,200,512,512);
	cut_out("inb1.yuv",200,400,512,512);
	cut_out("in11.yuv",190,90,128,128); exit(1);
	cut_out("d22c.yuv",1280-256-100,960-256,512,512); exit(1);
	cut_out("2916c.yuv",1280/2-256,960/2-256+128,512,512); exit(1);
	*/
#ifdef CUT_OUT
	{
		int x,y;
		peak_pos_x= peak_pos_y= 0;
		while((x=peak_pos_x)==0 || (y=peak_pos_y)==0){ usleep(100000); wt(&in,"get up-left pos"); }
		//printf("%d %d\n",x,y);
		cut_out("cut.yuv",x,y,512,512); exit(1);
		//cut_out("cut_fr2.yuv",x,y,500,400); exit(1);
		//cut_out("cut_to2.yuv",416,169,500,400); exit(1);
	}
#endif
	//draw_rect(416*.3,169*.3,500*.3,400*.3);
	//write_out(sizeof(Sif),"out_2.yuv"); exit(1);
	sprintf(name,"convert -size %dx%d %s out0.jpg",sx,sy,*v); system(name);

	deconv(0,0,sx,sy,sz,mat2);

	write_out(sz,"o.yuv");
	sprintf(name,"convert -size %dx%d o.yuv out.jpg",sx,sy); system(name);
	system("rm o.yuv");

	//while(1) { wt(&ot,"complete"); usleep(100000); }
	return 0;
}
